<?php

namespace api\controllers;

use api\controllers\BaseController;
use common\classes\Common;
use common\classes\Error;
use common\components\SendCmdToCmpn;
use common\models\BaseInfo;
use common\models\BroadcastMode;
use common\models\DevClasses;
use common\models\DeviceList;
use common\models\Event;
use common\models\PlaySessions;
use common\models\PwrDisplaySet;
use common\models\SystemLog;
use common\models\TaskTemplate;
use common\models\UserDevices;
use common\models\Users;
use common\models\VDevice;
use common\models\VMediaFiles;
use common\models\VSessionInfo;
use yii;

class DashboardController extends BaseController
{
    public function actionDevStatStatistics()
    {
        $data = Yii::$app->request->post('data');
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('dashboard' ,'DevStatStatistics', $data);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS,$ret->data);
    }

    public function actionMediaStatistics () {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('dashboard' ,'MediaStatistics', [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS,$ret->data);
    }

    public function actionSessionStatistics() {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('dashboard' ,'SessionStatistics', [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS,$ret->data);
    }

    public function actionUserStatistics () {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('dashboard' ,'UserStatistics', [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS,$ret->data);
    }

    public function actionLogStatistics () {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('dashboard' ,'LogStatistics', [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS,$ret->data);
    }

    public function actionSystemStatistics () {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('dashboard' ,'SystemStatistics', [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS,$ret->data);
    }

    public function actionAuthLogStatistics () {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('dashboard' ,'AuthLogStatistics', [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS,$ret->data);
    }

    //状态实时总览
    public function actionStatusRefresh(){
        $data = Yii::$app->request->post('data');
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('dashboard' ,'StatusRefresh', $data);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS,$ret->data);
    }
}
