<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/05/04 12:37
 */
namespace api\controllers;

use common\classes\Common;
use common\classes\Error;
use common\components\SendCmdToCmpn;
use Yii;
use yii\helpers\ArrayHelper;

/**
 * Datetime controller
 */
class DatetimeController extends BaseController
{
    public function actionView(){
        $reqData['access_token'] = $this->accessToken;
        $req = SendCmdToCmpn::SendCommonCmdNoID('datetime','View',$reqData);
        if (empty($req)) {
            return $this->response(Error::STATUS_FAILED);
        }
        if (!array_key_exists('data',$req)) {
            return $this->response($req->errCode);
        }
        return $this->response($req->errCode,$req->data);
    }

    public function actionZoneList(){
        $reqData['access_token'] = $this->accessToken;
        $req = SendCmdToCmpn::SendCommonCmdNoID('datetime','ZoneList',$reqData);
        if (empty($req)) {
            return $this->response(Error::STATUS_FAILED);
        }
        if (!array_key_exists('data',$req)) {
            return $this->response($req->errCode);
        }
        return $this->response($req->errCode,$req->data);
    }

    public function actionUpdate(){
        $data = Yii::$app->request->post('data');
        if(empty($data))
            return $this->response(Error::STATUS_PARAM_ERROR);

        if(isset($data['timezone']))
            Yii::$app->base->timezone = $data['timezone'];
        $reqData['access_token'] = $this->accessToken;
        $reqData['host'] = $this->clientIP;
        $reqData = array_merge($reqData,$data);
        $req = SendCmdToCmpn::SendCommonCmdNoID('datetime','Update',$reqData);
        if (empty($req)) {
            return $this->response(Error::STATUS_FAILED);
        }
        if (!array_key_exists('data',$req)) {
            return $this->response($req->errCode);
        }
        return $this->response($req->errCode,$req->data);
    }
}