<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/1/12 14:37
 */
namespace api\controllers;

use common\classes\Common;
use common\models\DeviceList;
use common\models\Event;
use common\models\UserDevices;
use common\models\Users as User;
use common\models\VDevClasses;
use common\models\VDevice;
use Yii;
use yii\db\Exception;
use yii\filters\VerbFilter;
use common\classes\Error;
use common\models\DevClasses;
use yii\helpers\ArrayHelper;

/**
 * Site controller
 */
class DeviceClassController extends BaseController
{
    public $allPri;
    public $uid;
    public $changecache = ['delete', 'new', 'move'];

    /*
     * get All Device Class
     */
    public function actionList(){
        $data = Yii::$app->getRequest()->post('data');
        $param = [
            'access_token'=>$this->accessToken
        ];
        if ($data!=null){
            $param['condition'] =$data;
        }

        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'ClassList', $param);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS,$ret->data);
    }
    /*
     * create device class
     */
    public function actionNew(){
        $data = Yii::$app->getRequest()->post('data');
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'NewClass', ['Name'=>$data['Name'],
            'Parent'=>intval($data['Parent']),
            'access_token'=>$this->accessToken]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    /*
     * update device class
     */
    public function actionUpdate(){
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data) || !isset($data['ClassID']))
            return $this->response(Error::STATUS_PARAM_ERROR);

        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'UpdateClass', ['ClassID'=>$data['ClassID'],
            'Name'=>$data['Name'],
            'Parent'=>intval($data['Parent']),
            'access_token'=>$this->accessToken]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }
    /*
     * update device class
     */
    public function actionDelete(){
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data) || !isset($data['ClassID']))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'DeleteClass', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS);
    }

    /*
     * add device
     */
    public function actionMove(){
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data) || !isset($data['source']) || !isset($data['target']))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $src = $data['source'];
        $tgt = $data['target'];

        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'UpdateParent', [
            'sourceClassID' => $src['classes'],
            'devices' => $src['devices'],
            'targetClassID' => $tgt['class'],
            'access_token'=>$this->accessToken
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS);
    }
//
//    public function actionGetAllDevice(){
//        $classList = DevClasses::find()->select(['ClassID', 'Name', 'Parent'])
//            ->asArray()
//            ->all();
//        $classes = [];
//        foreach ($classList as $item) {
//            if($item['Parent'] == null)
//                $item['Parent'] = 0;
//            $classes[$item['ClassID']] = $item;
//        }
//        $classes[0] = ['ClassID'=>null, 'Name'=>null, 'Parent'=>null];
//
//        $ret = [];
//        foreach ($classes as $id => $class){
//            $tmp['ClassID'] = $id;
//            $tmp['Name'] = $class['Name'];
//            $tmp['Parent'] = $class['Parent'];
//
//            $query =  DeviceList::find()->select(['DevID', 'Dev_Name'])->where(['not like', 'DevID', '68%', false]);
//            if($id == 0)
//                $device = $query->andWhere('Parent is null')->asArray()->all();
//            else
//                $device = $query->andWhere(['Parent'=>$id])->asArray()->all();
//            $tmp['Device'] = $device;
//
//            $ret[] = $tmp;
//        }
//
//        return $this->response(Error::STATUS_SUCCESS, $ret);
//    }
//
//    public function actionPriDevice($id){
//        if(empty($id) || !is_numeric($id))
//            return $this->response(Error::STATUS_PARAM_ERROR);
//        $data = \Yii::$app->getRequest()->post('data');
//        $query = VDevice::find();
//        $this->listQuery($query,$data);
//
//        //具有全部设备的使用权限
//        $user = User::findOne(['User_ID' => $id]);
//        if($id == 0 || ($user && (($user->privilege & 0x40000000) != 0 || ($user->Dev_Privilege & 1) ==1))){
//            $list = $query->all();
//            $useDevice = [];
//            foreach ($list as $dev)
//                $useDevice []= $dev['id'];
//            return $this->response(Error::STATUS_SUCCESS, ['useDevices' => $useDevice, 'devList'=>$list]);
//        }
//        //具有部分设备的使用权限
//        if($user->Dev_Privilege != 1) {
//            $useDevice = [];
//            $devices = UserDevices::find()
//                ->select(['DevID'])
//                ->where(['UserID' => $id])
//                ->andWhere('Pri & 1 = 1')
//                ->asArray()
//                ->all();
//            foreach($devices as $dev)
//                $useDevice[] = $dev['DevID'];
//            $list = $query->andWhere(['in', 'id', $useDevice])->all();
//            return $this->response(Error::STATUS_SUCCESS, ["useDevices" => $useDevice, "devList" => $list]);
//        }
//    }
}
