<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/1/12 14:37
 */
namespace api\controllers;

use common\classes\Common;
use common\models\VDevClasses;
use common\models\VDevice;
use common\models\UploadFile;
use Yii;
use common\classes\Error;
use yii\web\UploadedFile;

/**
 * Site controller
 */
class DeviceController extends BaseController
{
    public $configAction = ['set-config', 'delete'];
    public $changecache = ['delete', 'copy'];
    //非web控制台用户管理员和超级管理员
    public $isManagerFlag = false;
    public $isSuperFlag = false;
    private $firmwareDownloading = [];
    public function beforeAction($action)
    {
        $ret = parent::beforeAction($action); // TODO: Change the autogenerated stub
        if (!$ret) {
            return $ret;
        }
        return $ret;
    }

    /**
     * get user's mgr devices(db Query)
     * @return $this|null|\yii\db\ActiveQuery
     */
    private function newQuery(){
        $data = array();
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('user' ,'DeviceList', $data);
        return $ret;
    }

    /*
     * get All Device Class
     */
    public function actionGetConfig(){
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data) || !isset($data['id']))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCmd('GetConfig', $data['id'], $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if(isset($ret->data)){
            return $this->responseByGoRet($ret->errCode,$ret->errMsg,$ret->data);
        }else{
            return $this->responseByGoRet($ret->errCode,$ret->errMsg);
        }
    }

    public function actionSetConfig(){
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data) || empty($data['id']) || !preg_match('/^[0-9][0-9]+[0-9]$/', $data['id']))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $id = $data['id'];
        $data['access_token'] = $this->accessToken;
        $data['host'] = $this->clientIP;
        $ret = Yii::$app->sendcmd2cmpn->sendCmd('Config', $id, $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS);
    }

    public function actionStatus(){
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data))
            return $this->response(Error::STATUS_PARAM_ERROR);

        $data['access_token'] = $this->accessToken;
        $data['wechatUser'] = intval(Yii::$app->getRequest()->get('userid'));
        $data['host'] = $this->clientIP;
        // TODO:此处的cloudlogin需要重新处理
        //微信扫码时，需要该标志去跳过access_token验证
        if (isset($data['iotList']) && $data['iotList'] == true) {
            $data['cloudLogin'] = true;
        }
        if (isset($data['search']) && empty($data['search'])) {
            $data['search']['invalid'] = true;
        }
        if (isset($data['order']) && empty($data['order'])) {
            $data['order']['invalid'] = true;
        }
        if (isset($data['class']) && empty($data['class'])) {
            $data['class'] = intval(0);
        }
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'Status', $data);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response($ret->errCode, $ret->data);
    }

    private function doCtrlNew ($data, $cloudLogin, $wechatUser= 0) {
        $devIDs = explode(",",$data['devices']);
        if(sizeof($devIDs)==0){
            return true;
        }
        if(sizeof($devIDs)==1){
            $devID=$devIDs[0];
            if (isset($data['iotStatus']) && strlen($data['iotStatus']) == 32 && ctype_xdigit($data['iotStatus'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('RfCtrl', $devID, ['Status' => $data['iotStatus'],
                    'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                    'host'=>$this->clientIP,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }

            if (isset($data['power'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('DevCtrl', $devID, ['PowerOn' => $data['power'],
                    'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                    'host'=>$this->clientIP,'wechatUser'=> $wechatUser,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            if (isset($data['pc'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('DevCtrl', $devID, ['pcPowerOn' => $data['pc'],
                    'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                    'host'=>$this->clientIP,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            if (isset($data['projector'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('DevCtrl', $devID, ['projectorPowerOn' => $data['projector'],
                    'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                    'host'=>$this->clientIP,'wechatUser'=> $wechatUser,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            if (isset($data['projector2'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('DevCtrl', $devID, ['projector2PowerOn' => $data['projector2'],
                    'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                    'host'=>$this->clientIP,'wechatUser'=> $wechatUser,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            if (isset($data['audioMute'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('VolumeCtrl', $devID, ['mainVolumeMute' => $data['audioMute'],
                    'access_token'=>$this->accessToken,
                    'host'=>$this->clientIP,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            if (isset($data['micMute'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('VolumeCtrl', $devID, ['micVolumeMute' => $data['micMute'],
                    'access_token'=>$this->accessToken,
                    'host'=>$this->clientIP,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            if (isset($data['micVol']) && is_numeric($data['micVol'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('VolumeCtrl', $devID, ['micVolume' => $data['micVol'],
                    'access_token'=>$this->accessToken,
                    'host'=>$this->clientIP,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            if (isset($data['audioVol']) && is_numeric($data['audioVol'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('VolumeCtrl', $devID, ['mainVolume' => $data['audioVol'],
                    'access_token'=>$this->accessToken,
                    'host'=>$this->clientIP,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            if (isset($data['projectorSrc'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('VideoChannelCtrl', $devID, ['projectorChannelSource' => $data['projectorSrc'],
                    'access_token'=>$this->accessToken,
                    'host'=>$this->clientIP,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            if (isset($data['scene'])) {
                $ret = Yii::$app->sendcmd2cmpn->sendCmd('SceneCtrl', $devID, ['SceneNow' => $data['scene'],
                    'access_token'=>$this->accessToken,
                    'host'=>$this->clientIP,
                ]);
                if (!$ret || $ret->errCode != 0)
                    return false;
            }
            return true;
        }
        return $this->doCtrlBash($data,$cloudLogin);
    }

    //doCtrlBash 不关心操作是否成功，直接返回成功
    public function doCtrlBash($data, $cloudLogin){
        //以下是批量接口
        if (isset($data['iotStatus']) && strlen($data['iotStatus']) == 32 && ctype_xdigit($data['iotStatus'])) {
            $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'RfCtrlBash', ['Status' => $data['iotStatus'],
                'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                'host'=>$this->clientIP,
                'devices'=>$data['devices'],
            ]);
            if (!$ret || $ret->errCode != 0)
                return false;
        }
        if (isset($data['power'])) {
            $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'DevCtrlBash', ['PowerOn' => $data['power'],
                'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                'host'=>$this->clientIP,
                'devices'=>$data['devices'],
            ]);
            if (!$ret || $ret->errCode != 0)
                return false;
        }
        if (isset($data['pc'])) {
            $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'DevCtrlBash', ['pcPowerOn' => $data['pc'],
                'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                'host'=>$this->clientIP,
                'devices'=>$data['devices'],
            ]);
            if (!$ret || $ret->errCode != 0)
                return false;
        }
        if (isset($data['projector'])) {
            $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'DevCtrlBash', ['projectorPowerOn' => $data['projector'],
                'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                'host'=>$this->clientIP,
                'devices'=>$data['devices'],
            ]);
            if (!$ret || $ret->errCode != 0)
                return false;
        }
        if (isset($data['projector2'])) {
            $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'DevCtrlBash', ['projector2PowerOn' => $data['projector2'],
                'access_token'=>$this->accessToken, 'cloudLogin'=>$cloudLogin,
                'host'=>$this->clientIP,
                'devices'=>$data['devices'],
            ]);
            if (!$ret || $ret->errCode != 0)
                return false;
        }
        return true;
    }

    public function actionCloudControl(){
        // Cloud channel
        // TODO:cloudlogin 需要处理
        $cloudLogin = true;
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data) || !isset($data['devices']) || !preg_match('/^[0-9][0-9,]+[0-9]$/', $data['devices']))
            return $this->response(Error::STATUS_PARAM_ERROR, $data);

        $data['cloudLogin'] = $cloudLogin;
        $data['host'] = $this->clientIP;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'CloudCtrl', $data);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        $user = $ret->data->user;
        $device = $ret->data->device;

        $return = false;
        $pcNprjOp = (array_key_exists('pc', $data) || array_key_exists('projector', $data));
        if ($device->power === 'off' && $pcNprjOp) {
            return $this->response(Error::STATUS_DEVICE_POWER_OFF);
        }
        if ($device->power === 'disable' && $pcNprjOp) {
            return  $this->response(Error::STATUS_DEVICE_IS_DISABLED);
        }

        do {
            // admin & super
            if ($user->User_ID === 0 || ($user->privilege & 0x40000000)) {
                $return = $this->doCtrlNew($data, $cloudLogin, $data['userid']);
                break;
            }
            // Mgr user
            if ((($user->privilege & 0x01) && !empty($user->User_Name))) {
                if ($user->Mgr_Privilege == 1) {
                    $return = $this->doCtrlNew($data, $cloudLogin, $data['userid']);
                    break;
                }
                if (!empty($ret->data->userMgrDevice)) {
                    $return = $this->doCtrlNew($data, $cloudLogin, $data['userid']);
                    break;
                }
            }
            if ($device->power === 'disable') {
                return $this->response(Error::STATUS_DEVICE_IS_DISABLED);
            }
            if ($user->Dev_Privilege == 1) {
                $return = $this->doCtrlNew($data, $cloudLogin, $data['userid']);
                break;
            }
            if (!empty($ret->data->userUseDevice)) {
                $return = $this->doCtrlNew($data, $cloudLogin, $data['userid']);
                break;
            }
            if ($ret->data->timetable != 0) {
                $return = $this->doCtrlNew($data, $cloudLogin, $data['userid']);
                break;
            }
        }while(false);
        if ($return) {
            return $this->response(Error::STATUS_SUCCESS, $device->name);
        }
        return $this->response(Error::STATUS_FAILED, $device->name);
    }


    public function actionControl(){
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data))
            return $this->response(Error::STATUS_PARAM_ERROR, $data);
        if (isset($data['devices']) && $data['devices'] != 'all'){
            if (!preg_match('/^[0-9][0-9,]+[0-9]$/', $data['devices'])) {
                return $this->response(Error::STATUS_PARAM_ERROR, $data);
            }
        } else if (isset($data['allDevice']) || $data['devices'] == 'all') {
            $ret = $this->newQuery();
            if (!$ret || $ret->errCode != 0)
                return $this->response(Error::STATUS_FAILED);

            $ids = [];
            foreach ($ret->data as $id) {
                $ids[] = $id;
            }
            if (empty($ids))
                return $this->response(Error::STATUS_FAILED, 'id');
            $result = [];
            if (isset($data['key']) && !is_null($data['key']['parent'])) {
                $result = $this->findAreaDevice($ids, $data['key']['parent'], $result, true);
            } else {
                $result = $ids;
            }
            $data['devices'] = implode(',', $result);
        } else {
            return $this->response(Error::STATUS_PARAM_ERROR, $data);
        }
        $data['host'] = $this->clientIP;
        // TODO:cloudlogin

        $cloudLogin = false;
        $ret =  $this->doCtrlNew($data, $cloudLogin);

        if ($ret) {
            return $this->response(Error::STATUS_SUCCESS, $data['devices']);
        }
        return $this->response(Error::STATUS_FAILED, $data['devices']);
    }

    /**
     * @param $ids array 用户的管理设备id数组;
     * @param $areaId number 需要查找的分区id;
     * @param $result array 需要返回的查找结果;
     * @param $rootFlag boolean 是否需要获取自身的设备;
     * @return array
     */
    public function findAreaDevice ($ids, $areaId, $result, $rootFlag = false) {
        $query = VDevClasses::find();
        if ($rootFlag) {
            // 获取自己的设备
            $selfDevs = $query->where(['ClassID' => $areaId])->all();
            foreach ($selfDevs as $dev) {
                if (!is_null($dev->DevID)) {
                    if (in_array($dev->DevID, $ids))
                        $result[] = $dev->DevID;
                }
            }
        }
        $areaQuery = $query->where(['Parent' => $areaId]);
        $devArr = $areaQuery->all(); //设备
        foreach ($devArr as $dev) {
            // 分区下的设备
            if (!is_null($dev->DevID)) {
                if (in_array($dev->DevID, $ids))
                    $result[] = $dev->DevID;
            }
        }
        $areaArr = $areaQuery->all();
        foreach ($areaArr as $area) {
            // 分区下的分区,递归
            $result = $this->findAreaDevice($ids, $area->ClassID, $result);
        }
        return $result;
    }

    public function actionBrdMute($id, $mute) {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device', 'BroadcastCtrl',
            ['broadcastVolumeMute'=>$mute, 'id'=>$id, 'access_token'=>$this->accessToken,'host'=>$this->clientIP]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS);
    }

    public function actionTasks(){
        $data = Yii::$app->getRequest()->post('data');
        $param = [
            'id'=>$data['id'],
        ];
        if (isset($data['date'])) {
            $param['date'] = $data['date'];
        }
        $param['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'GetTasks', $param);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionCameraList($id){
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('device' ,'CameraList', $id, [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        $model = [
            'DevID' => $ret->data->DevID,
            'Dev_Name' => $ret->data->DevID,
            'RtspUrl' => $ret->data->RtspUrl,
            'RtspSub' => $ret->data->RtspSub,
            'RtspUrl1' => $ret->data->RtspUrl1,
            'RtspSub1' => $ret->data->RtspSub1,
        ];

        if ($ret->data->RecUrl)
            $model['RecUrl'] = json_decode($ret->data->RecUrl);
        return $this->response(Error::STATUS_SUCCESS, $model);
    }

    /*
     * delete offline device
     */
    public function actionDelete(){
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data) || !isset($data['id']) ||
            !preg_match('/^[0-9][0-9,]+[0-9]$/', $data['id']))
            return $this->response(Error::STATUS_PARAM_ERROR);

        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'Delete', ['id'=>$data['id'],
            'access_token'=>$this->accessToken,'host'=>$this->clientIP]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    /**
     * device (config/name+class/task+mode/privilege) copy
     */
    public function actionCopy(){
        $data = Yii::$app->getRequest()->post('data');
        if (is_null($data)
            || !isset($data['src']) || !preg_match('/^[0-9]+[0-9]$/', $data['src'])
            || !isset($data['dst'])  || !preg_match('/^[0-9][0-9,]+[0-9]$/', $data['dst'])
            || !isset($data['mask']) || !is_numeric($data['mask']))
            return $this->response(Error::STATUS_PARAM_ERROR);

        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'Copy',
            ['src'=>$data['src'],
             'dst'=>$data['dst'],
             'mask'=>$data['mask'],
                'access_token'=>$this->accessToken,
                'host'=>$this->clientIP,
            ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionPublicList () {
        $data = Yii::$app->getRequest()->post('data');
        if (is_null($data))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'PublicList', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response($ret->errCode, $ret->data);
    }

    public function actionGetFirmwareVersion () {
        $data = Yii::$app->getRequest()->post('data');
        if (empty($data) || empty($data['id']))
            return $this->response(Error::STATUS_PARAM_ERROR);

        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('device' ,'BaseInfo', $data['id'], $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        } else if ($ret->errCode != 0) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionFirmwareList() {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'FirmwareList', [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionFirmwareUpgrade() {
        $data = Yii::$app->request->post('data');
        if (empty($data) || empty($data['id']) || empty($data['filename']))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $file = Common::FIRMWARE_DIR . '/' . $data['filename'];
        $hasFile = false;
        $ids = explode(',', $data['id']);
        if(!file_exists($file)) {
            $isDownLoading = isset($this->firmwareDownloading[$data['filename']]) ? $this->firmwareDownloading[$data['filename']] : false;
            if (!$isDownLoading) {
                $content = file_get_contents(Common::FIRMWARE_WGET_LIST_FILE);
                if(empty($content)) {
                    return $this->response(Error::STATUS_FIRMWARE_LIST_EMPTY);
                }
                $content = unserialize($content);
                if(empty($content) || !is_array($content))
                    return $this->response(Error::STATUS_FIRMWARE_LIST_EMPTY);
                $downloadCmd = $content[$data['filename']];
                $this->firmwareDownloading[$data['filename']] = true;
                exec($downloadCmd);
            }
        } else {
            $hasFile = true;
        }
        $notExists = [];
        $offline = [];
        $file = '/firmware/' . $data['filename'];
        $upgradeList = [];
        if (file_exists(Common::FIRMWARE_UPGRADE_LIST_FILE)) {
            $upgradeList = file_get_contents(Common::FIRMWARE_UPGRADE_LIST_FILE);
            if (!empty($upgradeList)) {
                $upgradeList = unserialize($upgradeList);
                if (empty($upgradeList) || !is_array($upgradeList)) {
                    $upgradeList = [];
                }
            } else {
                $upgradeList = [];
            }
        }

        $retList = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("device", "List", ['ids' => $ids,
            'access_token'=>$this->accessToken]);
        if (!$retList) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($retList->errCode != Error::STATUS_SUCCESS) {
            return $this->response($retList->errCode);
        }
        if (empty($retList->data)) {
            return $this->response(Error::STATUS_SUCCESS);;
        }
        foreach ($ids as $id) {
            $flag = 0;
            foreach ($retList->data as $tmpDev) {
                if ($tmpDev->DevID != $id) {
                    continue;
                }

                if ($tmpDev->Online == false) {
                    $offline[] = [
                        'id' => $id,
                        'name' => $tmpDev->Dev_Name
                    ];
                    $flag = 1;
                    break;
                }

                $flag = 2;
                if ($hasFile) {
                    $ret = Yii::$app->sendcmd2cmpn->sendCmd('DevUpgrade', $id, ['url' => $file,
                        'access_token' => $this->accessToken]);
                    if ($ret) {
                        if ($ret->errCode == Error::STATUS_DEVICE_OFFLINE) {
                            $offline[] = [
                                'id' => $id,
                                'name' => $tmpDev->Dev_Name
                            ];
                        } else if ($ret->errCode != Error::STATUS_SUCCESS) {
                            return $this->response($ret->errCode);
                        }
                    } else {
                        $upgradeList[$id] = ['devId' => $id, 'file' => Common::FIRMWARE_DIR . '/' . $data['filename'], 'needUpgrade' => true];
                    }
                }
                break;
            }

            if ($flag == 0) {
                $notExists[] = [
                    'id' => $id
                ];
                continue;
            } else if ($flag == 1) {
                continue;
            }
        }
        file_put_contents(Common::FIRMWARE_UPGRADE_LIST_FILE, serialize($upgradeList));
        return $this->response(Error::STATUS_SUCCESS, ['offline' => $offline, 'notExists' => $notExists, 'download' => $this->firmwareDownloading]);
    }

    public function actionFirmwareUpload() {
        $model = new UploadFile();
        if (Yii::$app->request->isPost) {
            $model->firmwareFile = UploadedFile::getInstanceByName('firmwareFile');
            if (empty($model->firmwareFile)) {
                return $this->response(Error::STATUS_FAILED);
            }
            $path = Common::FIRMWARE_DIR.'/' . $model->firmwareFile->name;
            if (file_exists($path)) {
                $ret['md5'] = md5_file($path);
                return $this->response(Error::STATUS_SUCCESS, $ret);
            }
            if ($model->upload(Common::FIRMWARE_DIR)) {
                $ret['md5'] = md5_file($path);
                return $this->response(Error::STATUS_SUCCESS, $ret);
            }
            return $this->response(Error::STATUS_FAILED);
        }
    }

    public function actionFirmwareListUpdate() {
        $data = Yii::$app->request->post('data');
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'FirmwareListUpdate', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, [$data['id'] => $ret->data]);
    }

    public function actionRemoteCtrl(){
        $data = Yii::$app->request->post('data');
        if(empty($data) || !isset($data['id']))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('device' ,'RemoteCtrl', $data['id'], $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        $credit = Yii::$app->security->generateRandomString(16);
        Yii::$app->cache->set(Common::PC_REMOTE_CTRL_SALT . $credit, $ret->data, 60000);
        return $this->response(Error::STATUS_SUCCESS, ['credit' => $credit]);
    }

    public function actionReset()
    {
        $data = Yii::$app->getRequest()->post('data');
        if(empty($data) || empty($data['id']))
            return $this->response(Error::STATUS_PARAM_ERROR);

        if(isset($data['password'])) {
            $passwd = $data['password'];
            $ret = Yii::$app->sendcmd2cmpn->sendCmd('Reset', $data['id'], ['password' => $passwd,
                'access_token'=>$this->accessToken,'host'=> $this->clientIP]);
            if (!$ret) {
                return $this->response(Error::STATUS_FAILED);
            }
            if ($ret->errCode != Error::STATUS_SUCCESS) {
                return $this->response($ret->errCode);
            }
        }

        return $this->response(Error::STATUS_SUCCESS);
    }

    public function actionTroubleClean(){
        $data = Yii::$app->getRequest()->post('data');
        if(!array_key_exists('clean', $data) || !is_numeric($data['clean']) || empty($data['id'])|| !is_numeric($data['id']))
            return $this->response(Error::STATUS_PARAM_ERROR);

        if(isset($data['clean']))
        {
            $clean = $data['clean'];
            $cmpndata = ['trouble'=>$clean,'access_token'=>$this->accessToken,'host'=>$this->clientIP];
            $ret = Yii::$app->sendcmd2cmpn->sendCmd('CleanTrouble', $data['id'], $cmpndata);
            if (!$ret) {
                return $this->response(Error::STATUS_FAILED);
            }
            if ($ret->errCode != Error::STATUS_SUCCESS) {
                return $this->response($ret->errCode);
            }
        }

        return $this->response(Error::STATUS_SUCCESS);
    }

    public function actionSetSecondProjector(){
        $data = Yii::$app->request->post('data');
        if(empty($data) || !key_exists('support', $data) || !key_exists('name', $data))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $data['access_token'] = $this->accessToken;
        $data['host']= $this->clientIP;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'SetSecondProjector', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->actionGetSecondProjector();
    }

    public function actionGetSecondProjector(){
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'GetSecondProjector', ['access_token' => $this->accessToken]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionGetRtspUrl($id, $url_name) {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'GetRtspUrl', ['id'=>$id, 'urlName'=>$url_name,
            'access_token'=>$this->accessToken]);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }
    
    public function actionPusherGet(){
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'GetPusher', ['access_token'=>$this->accessToken]);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionPusherSet(){
        $data = Yii::$app->request->post('data');
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device' ,'SetPusher', $data);
        if (!$ret){
            return $this->response(Error::STATUS_FAILED);
        }
        if($ret->errCode != 0){
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }
}
