<?php
/**
 * User: marh(marh@idste.cn)
 * Date: 2020/1/8 17:20
 */
namespace api\controllers;

use common\classes\Error;
use common\models\DeviceExt;
use Yii;

/**
 * Event controller
 */
class DeviceExtController extends BaseController {
    public static $EXT_CFG_TYPE = ['RecorderCfg', 'RecorderUrl', 'SceneCfg'];

    /**
     * 获取配置内容
     * params: dev: 设备id, type: 配置名
     * @return array
     */
    public function actionGet () {
        $post = Yii::$app->getRequest()->post('data');
        if (empty($post) || !$post['dev'] || !$post['type']){
            return $this->response(Error::STATUS_PARAM_ERROR);
        }

        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('device',  'GetExtendedConfig', $post['dev'], [
            'type' => $post['type'],
            'access_token'=>$this->accessToken
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }
}
