<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/5/15 17:20
 */
namespace api\controllers;

use common\classes\Error;
use common\models\Event;
use common\models\EventModel;
use common\models\PlaySessions;
use common\models\VEvent;
use Yii;

/**
 * Event controller
 */
class EventController extends BaseController
{
    public function actionModelList() {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('server' ,'EventModelList', [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionList() {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('server' ,'EventList', [
            'access_token'=>$this->accessToken
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionDelete($id) {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('server' ,'DeleteEvent', $id, [
            'access_token'=>$this->accessToken,
            'host'=>$this->clientIP,
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS);
    }

    public function actionNew() {
        $data = Yii::$app->request->post('data');
        if(empty($data) || (!isset($data['StartTask']) && !isset($data['EndTask'])))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $data['access_token'] = $this->accessToken;
        $data['host'] = $this->clientIP;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('server' ,'NewEvent', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionUpdate($id) {
        $data = Yii::$app->request->post('data');
        if(empty($data) || (!isset($data['StartTask']) && !isset($data['EndTask'])))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $data['access_token'] = $this->accessToken;
        $data['host'] = $this->clientIP;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('server' ,'UpdateEvent', $id, $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }
}
