<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/5/17 17:57
 */
namespace api\controllers;

use common\classes\Common;
use common\classes\Error;
use common\models\CallWaiter;
use common\models\DeviceList;
use common\models\IpCall;
use common\models\VDevice;
use common\models\VIpCall;
use Yii;

/**
 * IP Call controller
 */
class IpcallController extends BaseController
{
    public function actionOnhook($id){
        $data = array('session' => $this->accessToken, 'access_token' => $this->accessToken);
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('ipcall', 'HangUp', $id, $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg);
    }

    public function actionOffhook($id){
        $data = array('session' => $this->accessToken, 'access_token' => $this->accessToken);
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('ipcall', 'PickUp', $id, $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg);
    }

    public function actionCall($deviceid){
        $listen = Yii::$app->request->get('listen');
        if ($listen == 'true') {
            $listen = 1;
        } else {
            $listen = 0;
        }
        $data = array('session' => $this->accessToken, 'listen' => $listen, 'access_token' => $this->accessToken);
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('ipcall', 'Request', $deviceid, $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg);
    }

    public function actionListen() {
        $data = array('session' => $this->accessToken, 'access_token' => $this->accessToken);
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('ipcall', 'Listen', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }

        return $this->responseByGoRet($ret->errCode, $ret->errMsg, $ret->data);
    }


    public function actionRequest($deviceid){
        $data = array('session' => $this->accessToken, 'access_token' => $this->accessToken);
        $post = Yii::$app->getRequest()->post('data');
        if(is_null($post) || !isset($post['offer']))
            return $this->response(Error::STATUS_PARAM_ERROR);

        $data['offer'] = $post['offer'];
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('ipcall', 'Connect', $deviceid, $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg, $ret->data);
    }
}
