<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/1/12 14:37
 */

namespace api\controllers;

use common\classes\Error;
use Yii;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;

/**
 * Site controller
 */
class NetworkController extends BaseController
{
    public function actionView()
    {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("network", "View", [
            'access_token' => $this->accessToken
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionUpdate()
    {
        $data = Yii::$app->request->post('data');
        $data['access_token'] = $this->accessToken;
        $data['host'] = $this->clientIP;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("network", "Update", $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        if(isset($ret->data)){
            return $this->response(Error::STATUS_SUCCESS, $ret->data);
        }
        return $this->response($ret->errCode);
    }
}