<?php
/**
 * User: liugh(liugh@idste.cn)
 * Date: 2020/08/11 11:37
 */

namespace api\controllers;

use common\classes\Error;
use Yii;


/**
 * Session Base controller
 */
class PcPlayerController extends BaseController
{
    public function actionView()
    {
        $data = array('access_token' => $this->accessToken);
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('player', 'GetInfo', 'pc', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != 0) {
            return $this->responseByGoRet($ret->errCode, $ret->errMsg);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg, $ret->data);
    }

    public function actionUpdate()
    {
        $data = Yii::$app->getRequest()->post('data');
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('player', 'SetInfo', 'pc', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg);
    }

    public function actionGetFiles()
    {
        $data = array();
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('player', 'GetFiles', 'pc', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != 0) {
            return $this->responseByGoRet($ret->errCode, $ret->errMsg);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg, $ret->data);
    }

    public function actionSetFiles()
    {
        $data = Yii::$app->getRequest()->post('data');
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('player', 'SetFiles', 'pc', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg);
    }

    public function actionGetDevices()
    {
        $data = array();
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('player', 'GetDevices', 'pc', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg, $ret->data);
    }

    public function actionSetDevices()
    {
        $data = Yii::$app->getRequest()->post('data');
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('player', 'SetDevices', 'pc', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg);
    }

    public function actionStart()
    {
        $data = Yii::$app->getRequest()->post('data');
        error_log("data " . json_encode($data));
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('player', 'Start', 'pc', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg, $ret->data);
    }

    public function actionStop()
    {
        $data = Yii::$app->getRequest()->post('data');
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('player', 'Stop', 'pc', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg);
    }

    public function actionGetStatus()
    {
        $data = array();
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmd('player', 'GetStatus', 'pc', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != 0) {
            return $this->responseByGoRet($ret->errCode, $ret->errMsg);
        }
        return $this->responseByGoRet($ret->errCode, $ret->errMsg, $ret->data);
    }
}
