<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/4/28 10:37
 */

namespace api\controllers;

use common\classes\Error;
use common\models\ProjectorType;
use Yii;

/**
 * Projector controller
 */
class ProjectorController extends BaseController
{
    public function actionList()
    {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device', 'ProjectorList', [
            'access_token' => $this->accessToken
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != 0) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionNew()
    {
        $data = Yii::$app->getRequest()->post('data');
        if (empty($data) || empty($data['Type']))
            return $this->response(Error::STATUS_PARAM_ERROR);

        $data['access_token'] = $this->accessToken;
        $data['host'] = $this->clientIP;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device', 'NewProjector', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != 0) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionUpdate($type)
    {
        $data = Yii::$app->getRequest()->post('data');
        if (empty($data))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $data['access_token'] = $this->accessToken;
        $data['host'] = $this->clientIP;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device', 'UpdateProjector', $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != 0) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionDelete($type)
    {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID('device', 'DeleteProjector', ['Type' => $type,
            'access_token' => $this->accessToken,
            'host' => $this->clientIP,
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != 0) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS);
    }
}
