<?php
/**
 * User: puww(puww@idste.cn)
 * Date: 2019/05/14 16:37
 */

namespace api\controllers;
use common\classes\Error;
use common\classes\HttpRequest;
use common\models\VDevice;
use Yii;

/**
 * Recorder controller
 */

class RecorderController extends BaseController
{
    public function actionFileList(){
        $data = Yii::$app->request->post('data');
        if(empty($data) || empty($data['deviceid']) || !is_numeric($data['deviceid']))
            return $this->response(Error::STATUS_PARAM_ERROR);

        $device = VDevice::find()->select(['ipaddress'])->where(['id'=>$data['deviceid']])->one();
        if(empty($device))
            return $this->response(Error::STATUS_DEVICE_NOT_EXISTS);
        if(empty($device->ipaddress))
            return $this->response(Error::STATUS_DEVICE_OFFLINE);

        $baseUrl = "http://" . $device->ipaddress . ":8080/";
        $reqUrl = $baseUrl . 'querydata';
        $downlodUrl = $baseUrl . 'action/down?video=';
        $req = new HttpRequest($reqUrl);
        $req->setHeader('Content-Type:application/x-www-form-urlencoded; charset=UTF-8');

        if(empty($data['page']) || !is_numeric($data['page']))
            $data['page']  = 1;
        if(empty($data['rows']) || !is_numeric($data['rows']))
            $data['rows'] = 30;
        if($data['szEdTime'] > date("Y-m-d",time()))
            $data['szEdTime'] = date("Y-m-d",time());
        $tmpCmd=['QueryData'=>['RecFile'=>['szStTime'=>$data['szStTime'], 'szEdTime'=>$data['szEdTime']]]];
        $szCmd = json_encode($tmpCmd, JSON_UNESCAPED_UNICODE);

        $reqpram = 'page=' . $data['page']. '&' . 'rows=' . $data['rows'] . '&' . 'szCmd='.$szCmd;
        $list = $req->post($reqpram);
        if(is_null($list) || $list->nRetVal != 0)
            return $this->response(Error::STATUS_FAILED);

        $ret = ['base'=>$downlodUrl, 'filelist'=>$list];
        return $this->response(Error::STATUS_SUCCESS, $ret);
    }
}