<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/5/8 19:20
 */

namespace api\controllers;

use common\classes\Common;
use common\classes\Error;
use common\models\SystemLog;
use Yii;

/**
 * System log controller
 */
class SlogController extends BaseController
{
    public function actionTypes()
    {
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("slog", "Types", [
            'access_token' => $this->accessToken
        ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionList()
    {
        $startDate = Yii::$app->getRequest()->get('startDate');
        $endDate = Yii::$app->getRequest()->get('endDate');
        $end = Yii::$app->getRequest()->get('end');
        $file = Yii::$app->getRequest()->get('file');
        $data = Yii::$app->getRequest()->post('data');
        $data["startDate"] = $startDate;
        $data["endDate"] = $endDate;
        $data["end"] = $end;
        $data['access_token'] = $this->accessToken;
        if (!$file) {
            $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("slog", "List", $data);
            if (!$ret) {
                return $this->response(Error::STATUS_FAILED);
            }
            if ($ret->errCode != Error::STATUS_SUCCESS) {
                return $this->response($ret->errCode);
            }
            return $this->response(Error::STATUS_SUCCESS, $ret->data);
        }
        $data["type"] = "system";
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("log", "Download", $data);//复用了download接口
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        $filepath = $ret->data->filepath;
        $filename = $ret->data->filename;
        Yii::$app->response->sendFile($filepath, $filename, ["mimeType" => "text/csv"]) && unlink($filepath);
    }

    public function actionView($id)
    {
        $data["id"] = intval($id);
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("slog", "View", $data);//复用了download接口
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionClean()
    {
        $startDate = Yii::$app->getRequest()->get('startDate');
        if (empty($startDate) || strptime($startDate, '%Y-%m-%d') == false)
            $startDate = '1000-01-01';

        $endDate = Yii::$app->getRequest()->get('endDate');
        if (empty($endDate) || strptime($endDate, '%Y-%m-%d') == false)
            $endDate = '9999-12-31';

        $cnt = Yii::$app->db
            ->createCommand("delete from SystemLog where at >= :startDate . ' 00:00:00' and at <= :endDate ' 23:59:59';", [
                ':startDate' => $startDate,
                ':endDate' => $endDate
            ])->execute();
        return $this->response(Error::STATUS_SUCCESS, ['rows' => $cnt]);

    }
}
