<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/5/3 10:34
 */

namespace api\controllers;

use common\classes\Error;
use common\models\PwrDisplaySet;
use common\models\VDeviceStatistic;
use Yii;

/**
 * Device Statistic controller
 */
class StatisticController extends BaseController
{
    public function actionList()
    {
        $file = Yii::$app->getRequest()->get('file');
        $data = Yii::$app->getRequest()->post('data');
        $startDate = Yii::$app->getRequest()->get('startDate');
        $endDate = Yii::$app->getRequest()->get('endDate');
        $data["startDate"] = $startDate;
        $data["endDate"] = $endDate;
        $data['access_token'] = $this->accessToken;
        if (!$file) {
            $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("statistics", "EnergyList", $data);
            if (!$ret) {
                return $this->response(Error::STATUS_FAILED);
            }
            if ($ret->errCode != Error::STATUS_SUCCESS) {
                return $this->response($ret->errCode);
            }
            return $this->response(Error::STATUS_SUCCESS, $ret->data);
        }
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("statistics", "EnergyListDownload", $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        $filepath = $ret->data->filepath;
        $filename = $ret->data->filename;
        return Yii::$app->response->sendFile($filepath, $filename, ["mimeType" => "text/csv"]) && unlink($filepath);
    }

    public function actionClean($startDate, $endDate)
    {
        if ($startDate == 'null')
            $startDate = '1000-01-01';
        else if (strptime($startDate, '%Y-%m-%d') == false)
            return $this->response(Error::STATUS_PARAM_ERROR);
        if ($endDate == 'null')
            $endDate = '9999-12-31';
        else if (strptime($endDate, '%Y-%m-%d') == false)
            return $this->response(Error::STATUS_PARAM_ERROR);
        $this->logTitle['title1'] = $startDate;
        $this->logTitle['title2'] = $endDate;
        $cnt = Yii::$app->db
            ->createCommand("delete from DeviceStatistic where StatisticDay >= ':startDate 00:00:00' and StatisticDay <= ':endDate 23:59:59';", [
                ':startDate' => $startDate,
                ':endDate' => $endDate,
            ])->execute();
        return $this->response(Error::STATUS_SUCCESS, ['rows' => $cnt]);
    }

    public function actionChartList()
    {
        $data = Yii::$app->getRequest()->post('data');
        $startDate = Yii::$app->getRequest()->get('startDate');
        $endDate = Yii::$app->getRequest()->get('endDate');
        $data["startDate"] = $startDate;
        $data["endDate"] = $endDate;
        $data['access_token'] = $this->accessToken;
        $ret = Yii::$app->sendcmd2cmpn->sendCommonCmdNoID("statistics", "EnergyChart", $data);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS, $ret->data);

    }
}