<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/04/18 17:59
 */

namespace api\controllers;

use common\models\SubNetwork;
use yii\db\Exception;
use yii\filters\VerbFilter;
use common\classes\Error;
use Yii;

/**
 * Sub NetWork controller
 */
class SubNetworkController extends BaseController
{
    public function actionList()
    {
        $ret = Yii::$app->sendcmd2cmpn
            ->sendCommonCmdNoID('network', 'ProxyList', [
                'access_token' => $this->accessToken,
            ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }

        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }

    public function actionUpdate($id, $mask, $ip)
    {
        if (ip2long($mask) === false || ip2long($ip) === false)
            return $this->response(Error::STATUS_PARAM_ERROR);
        $ret = Yii::$app->sendcmd2cmpn
            ->sendCommonCmdNoID('network', 'UpdateProxy', ['id' => (int)$id,
                'mask' => $mask,
                'ip' => $ip,
                'access_token' => $this->accessToken,
                'host'=>$this->clientIP,]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != 0) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS);
    }

    public function actionDelete($id)
    {
        $ret = Yii::$app->sendcmd2cmpn
            ->sendCommonCmdNoID('network', 'DeleteProxy', ['id' => (int)$id,
                'access_token' => $this->accessToken,
                'host'=>$this->clientIP,
                ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != 0) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS);
    }

    public function actionNew($mask, $ip)
    {
        if (ip2long($mask) === false || ip2long($ip) === false)
            return $this->response(Error::STATUS_PARAM_ERROR);
        $ret = Yii::$app->sendcmd2cmpn
            ->sendCommonCmdNoID('network', 'AddProxy', ['mask' => $mask,
                'ip' => $ip,
                'access_token' => $this->accessToken,
                'host'=>$this->clientIP,
                ]);
        if (!$ret) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($ret->errCode != Error::STATUS_SUCCESS) {
            return $this->response($ret->errCode);
        }
        return $this->response(Error::STATUS_SUCCESS, $ret->data);
    }
}
