<?php

namespace api\controllers;

use common\classes\Common;
use common\components\SendCmdToCmpn;
use common\models\BaseInfo;
use Yii;
use yii\filters\VerbFilter;
use common\classes\Error;
use yii\helpers\ArrayHelper;

/**
 * Site controller
 */
class SupportController extends BaseController
{
    public function actionUpdate($state)
    {
        $data = Yii::$app->request->post('data');
        if (is_null($data) || empty($data['description']))
            $description = null;
        else
            $description = $data['description'];
        $reqData['access_token'] = $this->accessToken;
        $reqData['host'] = $this->clientIP;
        $reqData = array_merge($reqData, ['state' => $state, 'description' => $description, 'uid' => 0]);
        $req = SendCmdToCmpn::SendCommonCmdNoID('support', 'Update', $reqData);
        if (empty($req)) {
            return $this->response(Error::STATUS_FAILED);
        }
        if (!array_key_exists('data', $req)) {
            return $this->response($req->errCode);
        }
        return $this->response($req->errCode, $req->data);
    }

    public function actionView()
    {
        $reqData['access_token'] = $this->accessToken;
        $req = SendCmdToCmpn::SendCommonCmdNoID('support', 'View', $reqData);
        if (!$req) {
            return $this->response(Error::STATUS_FAILED);
        }
        if ($req->errCode != Error::STATUS_SUCCESS) {
            return $this->response($req->errCode);
        }
        return $this->response($req->errCode, $req->data);
    }
}
