<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2017/12/18 15:57
 */
namespace common\classes;

class Common
{
    const LOG_FILE = './log.txt';
    const UUID_MD5_PRESTR = 'idste-uuid.';
    const UNIONID_MD5_PRESTR = 'idste-unionid.';

    const LOGIN_TOKEN_CACHE_SALT = 'user.token.';
    const LOGIN_TOKEN_CACHE_PASSWORD = 'user.pw.';
    const LOGIN_TOKEN_CACHE_UNIONID = 'user.wc.';
    const LOGIN_TOKEN_CACHE_OTHER = 'user.ot.';
    const LOGIN_TOKEN_CACHE_OAUTH = 'user.oa.';

    const MESSAGE_TYPE_CACHE = 'msg.type';
    const USER_MODEL_CACHE ='user.model';
    const USER_MGR_DEVICE_CACHE = 'user.mgr';
    const OAUTH_CREDIT_CACHE_OAUTH = 'oauth.cr.';

    const USER_DEVICE_CLASS_LIST_CACHE = 'devicelist.cr';

    const IPCALL_LASTID_CACHE = 'ipcall.lastid';

    const USER_INFO_SALT = 'userinfo';

    const WECHAT_MSG_LEVEL_INFO = 'info';
    const WECHAT_MSG_LEVEL_WARN = 'warn';
    const WECHAT_MSG_LEVEL_DANGER = 'danger';

    /**base info */
    const BASE_CACHE_SALT = 'baseinfo';
    const BASE_ENABLED_TEMPLATE_ID = 257;
    const USER_DPM_LIST_CACHE_SALT = 'user-dpm.';
    const CACHE_SHORT_LIFE_TIME = 2;
    const TIMETABLE_INFO = 'tt_info.';

    const BASEINFO_SCHOOL_FULLNAME = 0x00;
    const BASEINFO_MODE_1 = 0x01;
    const BASEINFO_MODE_2 = 0x02;
    const BASEINFO_MODE_3 = 0x03;
    const BASEINFO_MODE_4 = 0x04;
    const BASEINFO_SERVER_ID = 0x10;
    const BASEINFO_ENABLE_TEMPLATE = 0x101;
    const BASEINFO_TIMETABLE_CLASSROOM_CHOICE = 0x117;
    const BASEINFO_ENABLE_TIMETABLE = 0x118;
    const BASEINFO_TIMETABLE_AUTO_PWRCTRL = 0x119;
    const BASEINFO_TIMETABLE_PWRON_AHEAD = 0x11a;
    const BASEINFO_TIMETABLE_PWROFF_DELAY = 0x11b;
    const BASEINFO_TIMETABLE_OPEN_DATE = 0x11c;
    const BASEINFO_TIMETABLE_TERM_NAME = 0x11d;
    const BASEINFO_TIMETABLE_ERROR_RECEIVER = 0x124;
    const BASEINFO_TIMETABLE_TERMNAME_MIN_ID = 0x300;
    const BASEINFO_TIMETABLE_TERMNAME_MAX_ID = 0x39F;
    const BASEINFO_SCHOOL_SHORTNAME = 0x138;
    const BASEINFO_SCHOOL_UUID = 0x139;
    const BASEINFO_SCHOOL_PRIVILEGE = 0x13a;
    const BASEINFO_MYSQL_BACKUP_INFO = 0x165;
    const BASEINFO_CLOUD_DOMAIN = 0x150;
    const BASEINFO_CLOUD_STATUS = 0x151;
    const BASEINFO_CLOUD_SECRET_TOKEN = 0x152;
    const BASEINFO_CLOUD_ACCESS_TOKEN = 0x153;
    const BASEINFO_SERVER_DOMAIN = 0x154;
    const BASEINFO_USER_MAGIC = 0x155;
    const BASEINFO_SUPPORT_STATE = 0x157;
    const BASEINFO_OAUTH_RESOURCE = 0x158;
    const BASEINFO_OFFLINE_WARNING_START = 0x170;
    const BASEINFO_OFFLINE_WARNING_END = 0x17f;
    const BASEINFO_DEVICE_STATISTICS_START = 0x180;
    const BASEINFO_DEVICE_STATISTICS_END = 0x18f;
    const BASEINFO_UPLOAD_FILES_CONFIG = 0x190;
    const BASEINFO_SERVER_VERSION = 0x200;
    const BASEINFO_CHANNEL_NAME_PROJECTOR = 0x191;
    const BASEINFO_CHANNEL_NAME_PREVIEW = 0x192;
    const BASEINFO_DINGTALK_CORPID = 0x210;
    const BASEINFO_DINGTALK_APPKEY = 0x211;
    const BASEINFO_DINGTALK_APPSECRET = 0x212;
    const BASEINFO_DINGDING_CORPID = 0x240;
    const BASEINFO_DINGDING_APPKEY = 0x241;
    const BASEINFO_DINGDING_APPSECRET = 0x242;
    const BASEINFO_APP_SOLUTION = 0x243;
    const BASEINFO_NTP_SERVER_LIST = 0x400;
    const BASEINFO_AUDIO_DELAY = 66048;
    const BASEINFO_SCAN_AND_POWERON = 11000;
    const BASEINFO_SECOND_PROJECTOR_SUPPORT = 0x193;
    const BASEINFO_CERTIFICATE_INFO = 0x196;
    const BASEINFO_PUSER_TS = 680000;

    const AUDIO_CODEC = [
        'celt' => 0,
//        'mp2' => 2,
//        'aac' => 3
    ];

    const VIDEO_CODEC = [
        'audio' => [
            'mp3' => 1,
            'mp2' => 2,
            'aac' => 3
        ],
        'video' => [
            'h264' => 0,
            'mpeg4' => 1,
            'mpeg2video' => 2
        ]
    ];
    const MEDIA_STORAGE_DIR = '/home/upload/media/';
    const CUSTOM_STORAGE_DIR = '/home/upload/custom';
    const MEDIA_TEMPORARA_DIR = '/home/upload/temp/';
    const IMAGE_STORAGE_DIR = '/home/www/html/static/image/';
    const MEDIA_CACHE_KEY = 'media';

    const ZONEINFO_PATH = '/usr/share/zoneinfo/';

    const IDATE_WORKER_COUNT = 2;

    const WS_WORKER_COUNT = 1;
    const WS_WORKER_PORT_START = 18065;

    const MSG_WORKER_COUNT = 1;
    const MSG_WORKER_PORT_START = 18060;
    const MSG_MAX_TRYCNT = 5;

    const MEDIAUPLOAD_WORKER_COUNT = 1;
    const MEDIA_CONV_PORT_START = 18050;

    const SYSTEM_DEAMON_PORT = 18040;


    //device control command
    const CTRL_CMD_POWER = 0x30;
    const CTRL_CMD_ENABLE = 0x3e;

    //device control parameter
    const CTRL_PARAM_POWER_ON = 1;
    const CTRL_PARAM_POWER_OFF = 0;
    const CTRL_PARAM_ENABLE = 1;
    const CTRL_PARAM_DISABLE = 0;

    const MYSQL_BACKUP_DIR = '/home/backup';

    const FIRMWARE_DIR = '/home/upload/firmware';
    const FIRMWARE_LIST_FILE = '/home/upload/firmware/list';
    const FIRMWARE_LOCAL_LIST_FILE = '/home/upload/firmware/local-list';
    const FIRMWARE_NAME_LIST_FILE = '/home/upload/firmware/name-list';
    const FIRMWARE_WGET_LIST_FILE = '/home/upload/firmware/wget-list';
    const FIRMWARE_UPGRADE_LIST_FILE = '/home/upload/firmware/upgrade-list';

    const PC_REMOTE_CTRL_SALT = 'rc_salt.';

    const DEVICE_TREE_SALT = 'devtreesale.';
    const DEVICE_LOG_STATISTICS_SALT = 'devlogsta.';

    const LANGUAGE_SUPPORT = ['zh-CN', 'en'];

    const USER_PRIVILEGE_SET = [
        'device' => 0x01,
        'dconfig' => 0x03,
        'ic' => 0x10,
        'log' => 0x20,
        'fcheck' => 0x180,
        'brd' => 0x100,
        'fshare' => 0x140,
        'ipcall' => 0x200,
        'mode' => 0x500,
        'template' => 0x900,
        'manual' => 0x1100,
        'rfview' => 0x2001,
        'rfctrl' => 0x12001,
        'realtime' => 0x104,
        'remotectrl' => 0x4001,
        'centerctrl' => 0x8001,
        'system' => 0x40000000
    ];
}
?>
