<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2017/12/18 15:57
 */
namespace common\classes;
use yii\helpers\Json;
use Yii;
class Error
{
    const STATUS_SUCCESS = 0;
    const STATUS_FAILED = -1;
    const STATUS_NOT_LOGIN = -2;
    const STATUS_UNKNOW = -3;
    const STATUS_PARAM_ERROR = -4;
    const STATUS_FORBID = -5;
    const STATUS_TRYAGAIN = -6;
    const STATUS_BLANK = -7;
    const STATUS_SIGNATURE_ERROR = -8;
    const STATUS_PRIVILEGE_ERROR = -9;
    const STATUS_ERROR_401 = 401;
    const STATUS_ERROR_404 = 404;
    const STATUS_ERROR_408 = 408;
    const STATUS_IDSTE_CODE_BEGIN = 10000;
    const STATUS_NEED_TOKEN = 10001;
    const STATUS_LOGIN_FAILED = 10002;
    const STATUS_PROXY_BROKEN = 10003;
    const STATUS_UNREGISTERED = 10004;
    const STATUS_CREDIT_INVALID = 10005;
    const STATUS_PROXY_OFFLINE = 10006;
    const STATUS_UNIONID_ERROR = 10007;
    const STATUS_ADMIN_FORBID = 10008;
    const STATUS_API_DEPRECATED = 10009;
    const STATUS_QRCODE_NOT_EXISTS = 10100;
    const STATUS_QRCODE_EXPIRED = 10101;
    const STATUS_QRCODE_NOT_SCANED = 10102;
    const STATUS_QRCODE_SCANED = 10103;
    const STATUS_USER_NOT_EXISTS = 10200;
    const STATUS_USER_NOT_BIND = 10201;
    const STATUS_USER_UNIONID_BOUND = 10202;
    const STATUS_USER_PASSWORD_ERROR = 10203;
    const STATUS_USER_ICCARD_EXIST = 10204;
    const STATUS_USER_PHONE_EXIST = 10205;
    const STATUS_USER_USERSN_EXIST = 10206;
    const STATUS_USER_UNIONID_NOT_BOUND = 10207;
    const STATUS_USER_USER_NAME_EXIST = 10208;
    const STATUS_USER_USBKEY_EXIST = 10209;
    const STATUS_USER_UNIONID_BOUND_OTHER = 10210;
    const STATUS_USER_IMPORT_FAILED = 10211;
    const STATUS_SITE_GET_QRCODE_ERROR = 10301;
    const STATUS_DEVICE_CHANGED = 10400;
    const STATUS_DEVICE_DELETE_ONLINE_FORBIND = 10401;
    const STATUS_DEVICE_NOT_EXISTS = 10402;
    const STATUS_DEVICE_OFFLINE = 10403;
    const STATUS_TEMPLATE_NOT_EXIST = 10404;
    const STATUS_MODE_NOT_EXIST = 10405;
    const STATUS_PLAYER_NOT_EXISTS = 10406;
    const STATUS_PLAYER_DELETE_ONLINE = 10407;
    const STATUS_SCHEDULE_NOT_EXISTS = 10408;
    const STATUS_PLAYER_OFFLINE = 10409;
    const STATUS_PC_PLAYER_DELETE_FORBID = 10410;
    const STATUS_SESSION_STATUS_CHANGED = 10411;
    const STATUS_MODE_NOT_EMPTY = 10412;
    const STATUS_TEMPLATE_NOT_EMPTY = 10413;
    const STATUS_ACTIVE_TEMPLATE_NOT_SET = 10414;
    const STATUS_PLAYER_STATUS_CHANGED = 10415;
    const STATUS_DEVICE_IPCALL_NOT_EXISTS = 10416;
    const STATUS_SESSION_NOT_EXISTS = 10417;
    const STATUS_DEVICE_IS_DISABLED = 10418;
    const STATUS_DEVICE_STATISTIC_CHANGED = 10419;
    const STATUS_FOLDER_NOT_EXISTS = 10420;
    const STATUS_FOLDER_PARENT_NOT_EXISTS = 10421;
    const STATUS_SRC_FOLDER_NOT_EXISTS = 10423;
    const STATUS_TGT_FOLDER_NOT_EXISTS = 10424;
    const STATUS_MEDIA_FILE_NOT_EXISTS = 10422;
    const STATUS_MEDIA_CODEC_NOT_SUPPORT = 10423;
    const STATUS_MEDIA_SAMPLER_RATE_ERROR = 10424;
    const STATUS_MEDIA_FILE_SAVE_ERROR = 10425;
    const STATUS_MEDIA_GET_INFO_FAILED = 10426;
    const STATUS_FILE_TYPE_ERROR = 10427;
    const STATUS_ICONFILE_TYPE_ERROR = 10429;
    const STATUS_FILE_ENCODING_ERROR = 10428;
    const STATUS_ALTERNATE_NOT_EXISTS = 10430;
    const STATUS_ALTERNATE_EXISTS = 10431;
    const STATUS_ALTERNATE_WEEKDAY_ERROR = 10432;
    const STATUS_APART_SESSION_CLONE_SUCCESS= 10433;
    const STATUS_SUBNETWORK_NOT_EXISTS = 10440;
    const STATUS_SUBNETWORK_EXISTS = 10441;
    const STATUS_SUBNETWORK_ERROR = 10442;
    const STATUS_SUBNETWORK_TOO_MANY = 10443;
    const STATUS_DEVICE_RC_NOT_CONFIG = 10444;
    const STATUS_DEVICE_RC_VIEW_PWD_NOT_CONFIG = 10445;
    const STATUS_DEVICE_RC_MAIN_PWD_NOT_CONFIG = 10446;
    const STATUS_DEVICE_POWER_OFF = 10447;
    const STATUS_PROJECTOR_NOT_EXIST = 10500;
    const STATUS_PROJECTOR_EXIST = 10501;
    const STATUS_SYSTEM_DATETIME_ERROR = 10600;
    const STATUS_FIRMWARE_LIST_EMPTY = 10601;
    const STATUS_FIRMWARE_NOT_EXISTS = 10602;
    const STATUS_FIRMWARE_UPDATE_CMD_SENDED = 10603;
    const STATUS_MESSAGE_NOT_EXISTS = 10700;
    const STATUS_EVENT_NOT_EXISTS = 10800;
    const STATUS_EVENT_SESSION_NOT_EXISTS = 10801;
    const STATUS_IPCALL_STATE_CHANGED = 10900;
    const STATUS_IPCALL_NOT_EXISTS = 10901;
    const STATUS_IPCALL_IS_TALKING = 10902;
    const STATUS_IPCALL_NOT_LISTEN = 10903;
    const STATUS_IPCALL_BUSY = 10904;
    const STATUS_TIMETABLE_NOT_EXIST = 11000;
    const STATUS_TIMETABLE_DISABLED = 11001;
    const STATUS_MYSQL_BACKUP_NOT_EXISTS = 11002;
    const STATUS_TIMETABLE_AT_SAME_TIME = 11003;
    const STATUS_NOT_SET_TERMNAME = 11004;
    const STATUS_CAM_ONVIF_INIT_FAILED = 11100;
    const STATUS_DEVICE_RTSP_EMPTY = 11101;
    const STATUS_DEVICE_RTSP_IDENTITY_ERROR = 11102;
    const STATUS_DEVICE_ONVIF_INITIAL_FAILED = 11103;
    const STATUS_DEVICE_RECORDER_URL_NOT_FIND = 11104;
    const STATUS_NOTIFICATION_TYPE_UNKNOWN = 11200;
    const STATUS_NOTIFICATION_HAS_BEEN_HANDLED = 11201;
    const STATUS_SECTION_EXIST = 11301;
    const STATUS_SCENE_NOT_EXIST = 11401;
    const STATUS_SCENE_ICON_UPLOADED_BUT_SET_FAILED = 11402;
    const STATUS_FILE_UPLOAD_FAILED = 11403;
    const STATUS_FILE_UPLOAD_SUCCESS = 11404;
    const STATUS_EXT_CFG_UNKNOWN = 11501;
    const STATUS_MINIAPP_CODE_INVALID = 20001;
    const STATUS_MINIAPP_OPENID_GET_ERROR = 20002;
    const STATUS_MINIAPP_NEED_USERINFO = 20003;
    const STATUS_FILE_NEED_CHECK = 20004;
    const STATUS_SESSION_ISPLAYING = 20005;
    const STATUS_DINGDING_NOT_INIT = 20006;
    const STATUS_DINGDING_ACCESS_TOKEN_GET_FAIL = 20007;
    const STATUS_DINGDING_USERID_GET_FAIL = 20008;
    const STATUS_DINGDING_USERINFO_GET_FAIL = 20009;
    const STATUS_DINGDING_USER_MOBILE_GET_FAIL = 20010;
    const STATUS_TABLE_USER_NEED_SN = 20011;
    const STATUS_SERVER_IP_NOT_IN_WHITE_LIST = 20012;
    const STATUS_SUPPORT_PROXY_NORMAL = 20200;
    const STATUS_SUPPORT_PROXY_ERROR = 20201;
    const STATUS_MEDIA_BIT_RATE_NOT_SUPPORT = 20202;
    const STATUS_MEDIA_RESOLUTION_NOT_SUPPORT = 20203;
    const STATUS_SERVER_RESTARTING = 20205;
    public static function getMessage($status)
    {
        return Yii::t('app/error', $status);
    }

    public static function jsonResponse($status, $data = null)
    {
        $ret = [
            'status' => $status,
            'message' => Yii::t('app/error', $status)
        ];
        if(!is_null($data))
            $ret['data'] = $data;
        return Json::encode($ret);
    }

    public static function serializeResponse($status, $data = null) {
        $ret = [
            'status' => $status,
        ];
        if(!is_null($data))
            $ret['data'] = $data;
        return serialize($ret);
    }
}
?>
