<?php
namespace common\classes;

class HttpRequest
{
    const URL_GET_QRCODE = '/api/qrcode/create';
    private $handle;
    public $error = "";
    
    public function __construct($url, $args = null)
    {
        $this->handle = curl_init();
        if(is_array($args)){
            foreach ($args as $key => $value){
                $vars_str[] = $key . '=' . urlencode($value);
            }
            $url = $url . '?' . implode('&', $vars_str);
        }
        else if(!is_null($args))
            $url = $url . '?' . $args;
    
        $header = array(
            "content-type: application/json; charset=UTF-8"
        );
        curl_setopt($this->handle,CURLOPT_HTTPHEADER, $header);
        curl_setopt($this->handle, CURLOPT_URL, $url);
        curl_setopt($this->handle, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($this->handle, CURLOPT_TIMEOUT, 10);
    }

    public function setHeader($type){
        curl_setopt($this->handle, CURLOPT_HTTPHEADER, [$type]);
    }

    public function post($data, $returnArray = false)
    {
        if(!is_string($data))
            $data = json_encode($data, JSON_UNESCAPED_UNICODE);
        curl_setopt($this->handle, CURLOPT_POSTFIELDS, $data);
        $output = curl_exec($this->handle);
        if ($output === false)
        {
            $this->error = curl_error($this->handle);
            return null;
        }
        $output = json_decode($output, $returnArray);
        if(is_null($output) || (!is_array($output) && !is_object($output)))
            return null;
        return $output;
    }
    
    public function get($returnArray = false)
    {
        curl_setopt($this->handle, CURLOPT_HEADER, 0);
        $output = curl_exec($this->handle);
        if ($output === false)
        {
            $this->error = curl_error($this->handle);
            return null;
        }
        $output = json_decode($output, $returnArray);
        if(is_null($output) || (!is_array($output) && !is_object($output)))
            return null;
        return $output;
    }
    
    public function __destruct()
    {
        curl_close($this->handle);
    }
}

?>