<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/1/18 9:30
 */

namespace common\classes;
use Yii;
use common\models\BaseInfo;


class System
{
    public static function getMac()
    {
        $dir = '/sys/class/net/';
        $macs = null;
        if ($dh = opendir($dir)) {
            while (($file = readdir($dh)) !== false) {
                if ($file == '.' || $file == '..' || $file == 'lo')
                    continue;
                $filename = $dir . '/' . $file . '/address';
                $fp = fopen($filename, 'r');
                $ret = fread($fp, filesize($filename));
                fclose($fp);
                $macs[] = trim($ret);
            }
        }
        closedir($dh);
        if(is_null($macs))
            return null;
        sort($macs, SORT_STRING);
        return $macs[0];
    }


    public static function getCloudInfo(){
        $list = BaseInfo::find()->where(['in', 'InfomationID', [313,336,338,339]])->indexBy('InfomationID')->all();

        //get cloud access_token from baseinfo where id=339
        if(!isset($list[339]) || is_null($list[339]->Description))
            return null;
        $info['access_token'] = $list[339]->Description;
        //get cloud host and ip from baseinfo where id=336
        $info['host'] = Yii::$app->base->cloudServer;
        $info['ip'] = gethostbyname($info['host']);
        //get secret_token from baseinfo where id=338
        if(!isset($list[338]) || is_null($list[338]->Description))
            return null;
        $info['secret_token'] = $list[338]->Description;

        //get uuid from baseinfo where id=313
        $baseInfo = BaseInfo::findOne(['InfomationID' => 313]);
        $uuid = Yii::$app->base->uuid;
        if(empty($uuid))
            return null;
        $info['uuid'] = $uuid;
        return $info;
    }
}