<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/4/3 11:58
 */

namespace common\components;

use common\classes\Common;
use common\models\Users;
use Yii;
use yii\db\Exception;

class Command extends yii\base\Component
{

    public function ctrl($devid, $ip, $cmd, $para1, $para2 = 0, $para3 = 0, $strext = null){
        if(empty($devid) || empty($ip) || is_null($cmd))
            return false;
        $cmd = Yii::$app->db->createCommand('call sp_send_dev_ctrl_cmd(:devid, :ip, :cmd, :para1, :para2, :para3, :strext);',[
            ':devid' => $devid,
            ':ip' => $ip,
            ':cmd' => $cmd,
            ':para1' => $para1,
            ':para2' => $para2,
            ':para3' => $para3,
            ':strext' => $strext
        ]);
        try{
            $cmd->execute();
            return true;
        }catch (Exception $e){}
        return false;
    }

    /**
     * send login message
     * @param Users $user
     * @param string $action
     */
    public function login(Users $user, $action = 'undefined'){
        if(!isset(self::LOGIN_ACTION_NAME[$action]))
            return;
        if(!empty($user->User_Desc))
            $name = $user->User_Name . '/' . $user->User_Desc;
        else
            $name = $user->User_Name;
        $body = [
            'type' => 'login_info',
            'uid' => $user->User_ID,
            'msg' => [
                'keyword1' => $name,
                'keyword2' => 'iDste控制台',
                'keyword3' => date("m-d H:i"),
                'remark' => "登录方式：". self::LOGIN_ACTION_NAME[$action]
            ],
            'level' => 'info'
        ];
        $port =  Common::MSG_WORKER_PORT_START + rand(0,  Common::MSG_WORKER_COUNT - 1);
        $this->send($port, $body);
    }
}