<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/4/3 11:58
 */

namespace common\components;

use common\classes\Common;
use common\classes\Error;
use Yii;

/**
 * called by workerman deamon progress only
 */
class Datetime extends yii\base\Component
{
    public function __construct(array $config = [])
    {
        if(posix_getuid() !== 0)
            throwException("datetime component can be called by root only!");
        parent::__construct($config);
    }

    private function getServerList(){
        exec("grep -E '^\s*(server|pool)' /etc/ntp.conf ", $output);
        if(count($output) == 0)
            return [];
        $ret = [];
        foreach ($output as $line) {
            $eles = preg_split('/ +/', trim($line));
            if(!$eles || count($eles) < 2 || ($eles[0] != 'pool' &&$eles[0] != 'server'))
                continue;
            $ret[] = $eles[1];
        }
        return $ret;
    }

    private function setServerList($list, $syncDate = true){
        if(is_null($list))
            return;
        exec('sed -i "/^\s*\(server\|pool\)/d" /etc/ntp.conf');
        $fp = fopen('/etc/ntp.conf', 'a');
        foreach ($list as $value) {
            if(preg_match('/[^a-z0-9\.\-]/', $value))
                continue;
            fwrite($fp, "server " . $value . "\n");
            if($syncDate) {
                system('ntpdate ' . $value . ' && hwclock -w', $ret_value);
                $syncDate = ($ret_value != 0);
            }
        }
        fclose($fp);
    }

    public function view(){
        $ret['timezone'] = Yii::$app->base->timezone;
        exec("date +'%Y-%m-%d %H:%M:%S'", $datetime);
        $ret['timenow'] = $datetime[0];
        $ret['server'] = $this->getServerList();
        if(count($ret['server'])==1&&$ret['server'][0]=='127.127.1.0'){
            $ret['ntpService'] = 'inactive';
            Yii::$app->base->baseGet(Common::BASEINFO_NTP_SERVER_LIST,$oldServers,$v);
            $ret['server'] = explode(",",$oldServers);
        }else{
            $ret['ntpService'] = 'active';
        }
        return $ret;
    }

    public function update($param) {
        if(isset($param['timezone']))
            Yii::$app->base->timezone = $param['timezone'];

        if(isset($param['timeset'])) {
            if (preg_match('/^[0-9]{4}-[0-9]{1,2}-[0-9]{1,2} +[0-9]{1,2}:[0-9]{1,2}:[0-9]{1,2}$/', $param['timeset'])) {
                echo "timeset\n";
                system('date -s "' . $param['timeset'] . '" && hwclock -w', $ret);
                if ($ret != 0)
                    return Error::jsonResponse(Error::STATUS_FAILED);
                $param['ntpService'] = 'inactive';
            } else
                return Error::jsonResponse(Error::STATUS_SYSTEM_DATETIME_ERROR);
        }

        $serverList = (isset($param['server']) && is_array($param['server'])) ? $param['server'] : null;
        $serverWrited = false;

        if(isset($param['ntpService'])) {
            if($param['ntpService'] == 'inactive'){
                $serverList = ["127.127.1.0"];
                exec('systemctl stop ntp');
                $this->setServerList($serverList, false);
                exec('systemctl start ntp && systemctl enable ntp');
            }
            else if($param['ntpService'] == 'active') {
                Yii::$app->base->baseSet(Common::BASEINFO_NTP_SERVER_LIST,implode(",",$serverList),0);
                exec('systemctl stop ntp');
                $this->setServerList($serverList, false);
                exec('systemctl start ntp && systemctl enable ntp');
            }
            $serverWrited = true;
        }
        if(!$serverWrited)
            $this->setServerList($serverList, false);

        if(isset($param['reboot']) && $param['reboot'] == true)
            Yii::$app->system->reboot();
        return $this->view();
    }
}
