<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2019/12/02 18:11
 */

namespace common\components;

use common\classes\Common;
use common\classes\HttpRequest;
use common\models\TmpStorage;
use Yii;

/**
 * called by workerman deamon progress only
 *
 * @property integer | boolean $weeknow
 */
class Utils extends yii\base\Component
{
    public function response($status, $data = null)
    {
        $ret = [
            'status' => $status,
            'message' => Yii::t('app/error', $status)
        ];
        if(!is_null($data))
            $ret['data'] = $data;
        return $ret;
    }

    public function weeknow() {
        $week = TmpStorage::findOne(['key' => 'week']);
        if($week)
            return $week;
        else
            return ['strv'=>'', 'intv'=>1];
    }

    public function nowday() {
        $nowday = TmpStorage::findOne(['key' => 'nowday']);
        if($nowday)
            return $nowday;
        else
            return ['strv'=>'', 'intv'=>date("N") - 1];
    }
    /**
     * @param $action string
     * @param $name string
     * @param $values string | array | object
     */
    //TODO nsq功能暂时停用，待后续版本处理, 影响功能有：课表信息实习更新
    public function sendMQ($action, $name, $values, $ext) {
        if(!$name || !is_string($name))
            return;
        $h = new HttpRequest("http://127.0.0.1:4151/pub", ['topic' => 'internal_api-call']);
        $h->post(['timestamp' => time(),'user' => Yii::$app->user->id, 'action' => $action, 'data' => ['name' => $name, 'values' => $values, 'ext'=>$ext]]);
    }

    //NSQ发送网络信息
    public function sendWebManageMQ($action,$data){
        $h = new HttpRequest("http://127.0.0.1:4151/pub", ['topic' => 'web_manage']);
        $h->post(['user' =>Yii::$app->user->id,'timestamp' => time(), 'action' => $action , 'data' => ['ip' => $data['ip']]]);
    }

    public function __get($name)
    {
        if(in_array($name, get_class_vars(self::className())))
            return $this->$name;
        $method = 'get' . ucfirst($name);
        if(!method_exists($this, $method))
            throwException('method or parameter not exists');
        return $this->$method();
    }

    public function __set($name, $value)
    {
        if(in_array($name, get_class_vars(self::className())))
            return $this->$name;
        $method = 'set' . ucfirst($name);
        if(!method_exists($this, $method))
            throwException('method or parameter not exists');
        return $this->$method($value);
    }
}
