<?php
return [
    'vendorPath' => dirname(dirname(__DIR__)) . '/vendor',
    'components' => [
        'cache' => [
            'class' => 'yii\caching\FileCache',
            'cachePath' => '/dev/shm/yii2cache',
            'defaultDuration' => 7200
        ],
        'i18n' => [
            'translations' => [
                'app*' => [
                    'class' => 'yii\i18n\PhpMessageSource',
                    'basePath' => '@common/messages',
                    'forceTranslation'=> true,
                    'fileMap' => [
                        'app' => 'app.php',
                        'app/error' => 'error.php',
                        'app/message' => 'message.php',
                    ],
                ],
            ],
        ],
        'media' => [
            'class' => 'common\components\Media'
        ],
        'udp' => [
            'class' => 'common\components\UdpService'
        ],
        'ilog' => [
            'class' => 'common\components\Ilog'
        ],
        'cmd' => [
            'class' => 'common\components\Command'
        ],
        'net' => [
            'class' => 'common\components\Network'
        ],
        'system' => [
            'class' => 'common\components\System'
        ],
        'base' => [
            'class' => 'common\components\Base'
        ],
        'utils' => [
            'class' => 'common\components\Utils'
        ],
        'sendcmd2cmpn' => [
            'class' => 'common\components\SendCmdToCmpn'
        ],
        'datetime' => [
            'class' => 'common\components\Datetime'
        ],
        'message' => [
            'class' => 'common\components\Message'
        ]
    ],
];
