<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "BrdModeMember".
 *
 * @property integer $DevIDMode
 * @property integer $BrdModeID
 * @property string $DeviceID
 *
 * @property BroadcastMode $brdMode
 * @property DeviceList $device
 */
class BrdModeMember extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'BrdModeMember';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['BrdModeID', 'DeviceID'], 'required'],
            [['BrdModeID'], 'integer'],
            [['DeviceID'], 'string', 'max' => 50],
            [['BrdModeID', 'DeviceID'], 'unique', 'targetAttribute' => ['BrdModeID', 'DeviceID'], 'message' => 'The combination of Brd Mode ID and Device ID has already been taken.'],
            [['BrdModeID'], 'exist', 'skipOnError' => true, 'targetClass' => BroadcastMode::className(), 'targetAttribute' => ['BrdModeID' => 'idBroadcastMode']],
            [['DeviceID'], 'exist', 'skipOnError' => true, 'targetClass' => DeviceList::className(), 'targetAttribute' => ['DeviceID' => 'DevID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'DevIDMode' => 'Dev Idmode',
            'BrdModeID' => 'Brd Mode ID',
            'DeviceID' => 'Device ID',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getBrdMode()
    {
        return $this->hasOne(BroadcastMode::className(), ['idBroadcastMode' => 'BrdModeID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getDevice()
    {
        return $this->hasOne(DeviceList::className(), ['DevID' => 'DeviceID']);
    }
}
