<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "BroadcastMode".
 *
 * @property integer $idBroadcastMode
 * @property string $ModeName
 * @property integer $Priority
 * @property integer $Enabled
 * @property string $StartTime
 * @property string $StopTime
 * @property integer $TimeStyle
 * @property integer $Active
 *
 * @property BrdModeMember[] $brdModeMembers
 * @property DeviceList[] $devices
 * @property PlaySessions[] $playSessions
 */
class BroadcastMode extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'BroadcastMode';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['Priority', 'Enabled', 'TimeStyle', 'Active'], 'integer'],
            [['StartTime', 'StopTime'], 'safe'],
            [['ModeName'], 'string', 'max' => 50],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'idBroadcastMode' => 'Id Broadcast Mode',
            'ModeName' => 'Mode Name',
            'Priority' => 'Priority',
            'Enabled' => 'Enabled',
            'StartTime' => 'Start Time',
            'StopTime' => 'Stop Time',
            'TimeStyle' => 'Time Style',
            'Active' => 'Active',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getBrdModeMembers()
    {
        return $this->hasMany(BrdModeMember::className(), ['BrdModeID' => 'idBroadcastMode']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getDevices()
    {
        return $this->hasMany(DeviceList::className(), ['DevID' => 'DeviceID'])->viaTable('BrdModeMember', ['BrdModeID' => 'idBroadcastMode']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPlaySessions()
    {
        return $this->hasMany(PlaySessions::className(), ['BrdMode' => 'idBroadcastMode']);
    }
}
