<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "DevClasses".
 *
 * @property integer $ClassID
 * @property string $Name
 * @property integer $Parent
 *
 * @property DevClasses $parent
 * @property DevClasses[] $devClasses
 * @property DeviceList[] $deviceLists
 * @property GroupCtrlSchedule[] $groupCtrlSchedules
 * @property PlayerKeys[] $playerKeys
 */
class DevClasses extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'DevClasses';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['Parent'], 'integer'],
            [['Name'], 'string', 'max' => 50],
            [['Parent'], 'exist', 'skipOnError' => true, 'targetClass' => DevClasses::className(), 'targetAttribute' => ['Parent' => 'ClassID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'ClassID' => 'Class ID',
            'Name' => 'Name',
            'Parent' => 'Parent',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getParent()
    {
        return $this->hasOne(DevClasses::className(), ['ClassID' => 'Parent']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getDevClasses()
    {
        return $this->hasMany(DevClasses::className(), ['Parent' => 'ClassID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getDeviceLists()
    {
        return $this->hasMany(DeviceList::className(), ['Parent' => 'ClassID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getGroupCtrlSchedules()
    {
        return $this->hasMany(GroupCtrlSchedule::className(), ['GroupID' => 'ClassID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPlayerKeys()
    {
        return $this->hasMany(PlayerKeys::className(), ['GroupID' => 'ClassID']);
    }
}
