<?php
/**
 * Created by PhpStorm.
 * User: haijun(xu_415@126.com)
 * Date: 2018/1/15
 * Time: 22:11
 */

namespace common\models;

use common\classes\Common;
use Yii;
use yii\db\Exception;

/**
 * Created by PhpStorm.
 * User: haijun(xu_415@126.com)
 * Date: 2017/7/10
 * Time: 23:44
 */
class DeviceConfig extends \yii\base\Model
{
    public $id; //device id
    public $name; //device name
    public $location; //position/description
    public $config = [
        'system' => [
            'enable' => 0,
            'deviceStartType' => 0,
            'deviceLinkProjector' => 0,
            'deviceLinkProjector2' => 0,
            'deviceLinkComputer' => 0,
            'deviceLinkMic' => 0,
            'broadcastLinkExtendPower' => 0,
            'presetHDMIRatio' => 0,
            'HDMIRatioType' => 0,
            'buildInHDMIAudio' => 0,
            'externalPowerOffDelay' => 0,
            'audoDectDelay' => 0,
            'AngBrdEnable' => 0,
            'brightEnFlag' => 0,
        ],
        'audio'  => [
            'broadcastVol' => 0,
            'dspEnFlag' => 0,
            'keepAudConfig' => 0,
            'keepMicConfig' => 0,
            'mainAudBass' => 0,
            'mainAudGain' => 0,
            'mainAudTreble' => 0,
            'mainAudVol' => 0,
            'micAudBass' => 0,
            'micAudGain' => 0,
            'micAudTreble' => 0,
            'micAudVol' => 0,
            'pantomPowerMic1On' => 0,
            'pantomPowerMic2On' => 0,
            'prjSignalSrc' => 0,
            'wireMic1Gain' => 0,
            'wireMic2Gain' => 0,
            'micEnhanceSrc' => 0,
        ],
        'projector'=> [
            'baudRate' => 0,
            'chnn1Code' => '',
            'chnn2Code' => '',
            'closeCode' => '',
            'sendInterval' => 0,
            'ext1SerialChnn' => 0,
            'ext2SerialChnn' => 0,
            'innerPcSerialChnn' => 0,
            'localVideoSerialChnn' => 0,
            'name' => '',
            'openCode' => '',
            'powerOffDelay' => 0,
            'screenDelay' => 0,
            'dataBit' => 0,
            'sendTimes' => 0,
            'stopBit' => 0,
            'verifySerialOddEven' => 0,
        ],
        'projector2' => [
            'name' => '',
            'powerOffDelay' => 0,
            'screenDelay' => 0,
            'verifySerialOddEven' => 0,
            'sendInterval' => 0,
            'stopBit' => 0,
            'baudRate' => 0,
            'dataBit' => 0,
            'sendTimes' => 0,
            'openCode' => '',
            'closeCode' => '',
            'chnn1Code' => '',
            'chnn2Code' => '',
        ],
        'extendIO' => [
            'config'=>[],
        ],
        'vlan' => [
            'TrunkPort' => 0,
            'config' => [],
        ],
        'recoderCfg' => [
            'rec_type' => '',
            "cmd_open" => '',
            "cmd_close" => '',
            "cmd_start" => '',
            "cmd_stop" => '',
            "cmd_pause" => '',
            "cmd_resume" => '',
            "recenflag" => 0,
            "check_bit" => 0,
            "stop_bit" => 0,
            "data_bit" => 0,
            "baud_rate" => 0,
            "pwrlinkage" => '',
        ],
        'pclinkCfg' => [
            'ip' => '',
            'mac' => '',
            'linkFlag' => 0,
        ],
        'sysAdvCfg' => [
            'extPwrDelay' => 0,
            'eleLockDelay' => 0,
            'cp02lcdDelay' => 0,
            'clockLinkSys' => 0,
            'extPwrLinkBrd' => 0,
            'rfDevOpenLink'=>[],
            'rfDevCloseLink'=>[],
            'preSignalSrc'=> 0,
            'cp02PrjCtrl'=> 0,
            'icPowerOffDelay'=> 0,
            'audSwitchEnFlag'=> 0,
            'linkPwrType'=> 0,
            'elelockLevel'=> 0,
            'igmpVer'=> 0,
            'ampType'=> 0,
            'videoInput1Type'=> 0,
            'videoInput2Type'=> 0,
            'videoInput3Type'=> 0,
            'videoOutPut1Type' =>0,
            'videoOutPut2Type' =>0,
            'mainDispInfoType'=>0,
            'secDispInfoType'=>0,
            'cp01RfCtrlFlag'=>0,
            'prjAlarmDis'=>0,
            'prj2CtrlIntfType'=>0,
            'extComCtrlType'=>0,
            'usb2SerialCtrlType'=>0,
            'langDis'=>0,
            'pwrOffLockTime'=>0,
            'phone'=>0,
            'micStubEn'=>0,
            'cp02rfDisableFlag'=>[],
            'lcdRfCtrl'=>[],
        ],
    ];
    public $rtspUrl;
    public $rtspSub;
    public $rtspUrl1;
    public $rtspSub1;

    public $MaintainQrcode;
    public $pcIp;
    public $pcPort;
    public $pcMainPasswd;
    public $pcViewPasswd;

    public $ProjWatermark;
    public $ProjUsedTime;

    public $RfInvalid;
    //高级配置标识
    public $optional;
    //外接电脑联动IP、MAC和联动关机标识
    public $ip;
    public $mac;
    public $recUrl;
    public $scenes;

    public function rules()
    {
        return [
            [['id'], 'required'],
            [['name'], 'string', 'max' => 64],
            [['location'], 'string', 'max' => 96],
            [['name', 'location'], 'trim'],
            ['pcIp', 'ip'],
            ['pcPort', 'integer', 'max' => 65535, 'min' => 1],
            ['optional', 'integer', 'max' => 65535, 'min' => 0],
            [['pcMainPasswd', 'pcViewPasswd'], 'string', 'max' => 32],
            [['rtspUrl', 'rtspSub', 'rtspUrl1', 'rtspSub1'], 'string', 'max' => 128],  //camera config
            [['rtspUrl', 'rtspSub', 'rtspUrl1', 'rtspSub1'], 'match', 'pattern' => '/^rtsp:\/\//i'],  //camera config
            [['ProjWatermark', 'ProjUsedTime', 'RfInvalid'], 'integer', 'min' => 0],
        ];
    }

    public function load($data, $formName = null)
    {
        $ret = parent::load($data, $formName); // TODO: Change the autogenerated stub

        if($ret === false)
            return $ret;
        $this->name = mb_strcut($this->name, 0, 32);
        return $this->validate();
    }

    public function save(){

        if(!preg_match('/^[0-9][0-9,]+[0-9]$/', $this->id))
            return false;
        //读取设备配置
        $ret = Yii::$app->sendcmd2cmpn->sendGetCmd('GetConfig', $this->id);
        if(!$ret || $ret->errCode != 0){
            return null;
        }
        usleep(1000000);
        $ids = explode(',', $this->id);
        if(empty($ids))
            return false;
        $config = $this->formatConfig($has_opt4);
        foreach($ids as $id){
            $vdevice = VDevice::findOne(['id' => $id]);
            $device = DeviceList::findOne(['DevID' => $id]);

            if (empty($this->rtspUrl))
                $device->RtspUrl = null;
            else if (!preg_match('/^rtsp:\/\/\*\*\*:\*\*\*@/i', $this->rtspUrl))
                $device->RtspUrl = $this->rtspUrl;
            if (empty($this->rtspSub))
                $device->RtspSub = null;
            else if (!preg_match('/^rtsp:\/\/\*\*\*:\*\*\*@/i', $this->rtspSub))
                $device->RtspSub = $this->rtspSub;
            if (empty($this->rtspUrl1))
                $device->RtspUrl1 = null;
            else if (!preg_match('/^rtsp:\/\/\*\*\*:\*\*\*@/i', $this->rtspUrl1))
                $device->RtspUrl1 = $this->rtspUrl1;
            if (empty($this->rtspSub1))
                $device->RtspSub1 = null;
            else if (!preg_match('/^rtsp:\/\/\*\*\*:\*\*\*@/i', $this->rtspSub1))
                $device->RtspSub1 = $this->rtspSub1;
            if(isset($this->RfInvalid) && is_numeric($this->RfInvalid))
                $device->RfInvalid = $this->RfInvalid;

            if(is_null($vdevice) || is_null($device))
                continue;

            // 录播配置
            if (isset($this->config['recoderCfg']) && !empty($this->config['recoderCfg'])) {
                $recExt = DeviceExt::findOne(['DevID' => $id, 'Name' => 'RecorderCfg']);
                if (!$recExt) {
                    $recExt = new DeviceExt();
                    $recExt->DevID = $id;
                    $recExt->Name = 'RecorderCfg';
                }
                $recExt->Config = json_encode($this->config['recoderCfg']);
                $recExt->save();
            }

            if ($device->ProjWatermark != $this->ProjWatermark || $device->ProjUsedTime != $this->ProjUsedTime) {
                $device->ProjUsedTime = $this->ProjUsedTime;
                $device->ProjWatermark = $this-> ProjWatermark;
                $device->save();
            }
            if($has_opt4) {
                if ($this->getDeviceOptionalConfigOld($device, $opt1, $opt2, $opt3, $opt4) && $opt4)
                    $new_config = $config . bin2hex(substr($opt4, 55, 201));
                else
                    $new_config = $config . $this->formatString('00', 201 * 2, true, false);
            }
            else
                $new_config = $config;
            $tmp = bin2hex($device->Dev_Configuration);
            if(count($ids) > 1){
                $realCfg = substr($tmp, 0, 256) . substr($new_config, 256);
                $sql = "call sp_send_dev_cfg_cmd('" . $vdevice->id . "', '" . $vdevice->ipaddress . "','" . $realCfg . "','','');";
            }
            else
                $sql = "call sp_send_dev_cfg_cmd('" . $vdevice->id . "', '" . $vdevice->ipaddress . "','" . $new_config . "','','');";
            Yii::$app->getDb()->createCommand($sql)->execute();
        }

        if(count($ids) == 1 && !is_null($vdevice) && !is_null($device)){
            $device->Dev_Description = iconv('UTF-8', 'GBK', $this->location);
            $device->Dev_Name = $this->name;

            if($this->pcMainPasswd !== '***')
                $device->PcMainPasswd = $this->pcMainPasswd;
            if($this->pcViewPasswd !== '***')
                $device->PcViewPasswd = $this->pcViewPasswd;
            $device->PcIp = $this->pcIp;
            $device->PcPort = $this->pcPort;
            return $device->save();
        }
        return true;
    }

    private function formatInt($value, $bytes) {
        $ret = '';
        for ($j = 0; $j < 8 * $bytes; $j += 8) {
            $val = ($value >> $j) % 256;
            $ret .= sprintf("%02x", $val);
        }
        return $ret;
    }
    private function formatString($str, $bytes, $padding = true, $bin2hex = true) {
        if($bin2hex)
            $ret =  bin2hex(substr($str, 0, $bytes));
        else
            $ret = substr($str, 0, $bytes);
        if($padding) {
            $step = $bin2hex ? 1:2;
            for ($j = strlen($str); $j < $bytes; $j += $step)
                $ret .= '00';
        }
        return $ret;
    }

    static function readInt($value, $bytes, &$i) {
        $ret = 0;
        for($j = 0; $j < $bytes * 8; $j += 8)
            $ret += hexdec(bin2hex($value[$i++])) << $j;
        return $ret;
    }

    /**
     * @param $device DeviceList
     * @param $opt1
     * @param $opt2
     * @param $opt3
     * @param $opt4
     * @return bool
     */
    private function getDeviceOptionalConfigOld($device, &$opt1, &$opt2, &$opt3, &$opt4) {
        $opt1 = $opt2 = $opt3 = $opt4 = null;
        if (!$device && substr($device->DevID, 0, 1) === '5')
            return false;
        $config = $device->Dev_Configuration;
        if(strlen($config) <= 480)
            return false;
        $opt1 = substr($config, 0, 480);
        /*480之后为高级配置*/
        $i = 480;
        $optional = self::readInt($config, 2, $i);
        // 第二路投影机配置
        if ($optional & 0x01) {
            if(strlen($config) < $i + 334)
                return false;
            $opt2 = substr($config, $i, 334);
            $i += 334;
        }
        if($optional & 0x02) {
            if(strlen($config) < $i + 66)
                return false;
            $opt2 = substr($config, $i, 66);
            $i += 66;
        }
        if($optional & 0x04){
            if(strlen($config) < $i + 1)
                return false;
            $sum = self::readInt($config, 1, $i);
            if(strlen($config) < $i + $sum * 4)
                return false;
            $opt3 = substr($config, $i - 1, 2 + $sum * 4);
            $i += $sum * 4 + 1;
        }
        if($optional & 0x08){
            if(strlen($config) < $i + 256)
                return false;
            $opt4 = substr($config, $i, 256);
        }
        return true;
    }

    private function formatConfig(&$has_opt4)
    {
        $has_opt4 = false;
        $name = bin2hex(iconv('UTF-8', 'GBK', mb_strcut($this->name, 0, 32)));
        $configArr = $name;
        for ($i = strlen($name); $i < 64; $i += 2)
            $configArr .= '00';
        $position = bin2hex(iconv('UTF-8', 'GBK', mb_strcut($this->location, 0, 96)));
        $configArr .= $position;
        for ($i = strlen($position); $i < 192; $i += 2)
            $configArr.= '00';
        //position 128
        $val = ($this->config['system']['deviceStartType'] << 4) + $this->config['system']['enable'];
        $configArr .= sprintf("%02x", $val);
        $val = $this->config['system']['AngBrdEnable'] & 1;
        $val += ( $this->config['audio']['wireMic1Gain'] & 0x07) <<2;
        $val += ( $this->config['audio']['wireMic2Gain'] & 0x07) <<5;
        $configArr .= sprintf("%02x", $val);
        $val = ($this->config['system']['deviceLinkProjector'] & 1) << 4;
        $val += ($this->config['system']['deviceLinkComputer'] & 1) << 5;
        $val += ($this->config['system']['deviceLinkMic'] & 1) << 6;
        $val += ($this->config['system']['deviceLinkProjector2'] & 1) << 7;
        $configArr .= sprintf("%02x", $val);
        $configArr .= sprintf("%02x", $this->config['system']['HDMIRatioType']);

        //position 132;
        $configArr .= $this->formatInt($this->config['system']['audoDectDelay'], 4);
        $configArr .= $this->formatInt($this->config['projector']['screenDelay'], 4);
        $configArr .= $this->formatInt($this->config['projector']['powerOffDelay'], 4);
        $mod = bin2hex(iconv('UTF-8', 'GBK', mb_strcut($this->config['projector']['name'], 0, 64)));
        $configArr .= $mod;
        for ($j = strlen($mod); $j < 128; $j += 2)
            $configArr .= '00';

        //position 208 proj_cmd_t
        $configArr .= sprintf("%02x", $this->config['projector']['verifySerialOddEven']);
        $configArr .= sprintf("%02x", $this->config['projector']['sendTimes']);
        $configArr .= sprintf("%02x", $this->config['projector']['sendInterval']);
        $configArr .= sprintf("%02x", $this->config['projector']['baudRate']);
        $len = strlen($this->config['projector']['openCode']) >> 1;
        $configArr .= sprintf("%02x", $len);
        $configArr .= $this->config['projector']['openCode'];
        for ($j = strlen($this->config['projector']['openCode']); $j < 126; $j += 2)
            $configArr .= '00';
        $len = strlen($this->config['projector']['closeCode']) >> 1;
        $configArr .= sprintf("%02x", $len);
        $configArr .= $this->config['projector']['closeCode'];
        for ($j = strlen($this->config['projector']['closeCode']); $j < 126; $j += 2)
            $configArr .= '00';
        $len = strlen($this->config['projector']['chnn2Code']) >> 1;
        $configArr .= sprintf("%02x", $len);
        $configArr .= $this->config['projector']['chnn2Code'];
        for ($j = strlen($this->config['projector']['chnn2Code']); $j < 126; $j += 2)
            $configArr .= '00';
        $len = strlen($this->config['projector']['chnn1Code']) >> 1;
        $configArr .= sprintf("%02x", $len);
        $configArr .= $this->config['projector']['chnn1Code'];
        for ($j = strlen($this->config['projector']['chnn1Code']); $j < 126; $j += 2)
            $configArr .= '00';
        //position 468
        if($this->config['audio']['keepAudConfig'] === 1)
            $this->config['audio']['mainAudVol'] = 255;
        if($this->config['audio']['keepMicConfig'] == 1)
            $this->config['audio']['micAudVol'] = 255;
        $configArr .= sprintf("%02x", $this->config['audio']['mainAudVol']);

        $configArr .= sprintf("%02x", $this->config['audio']['micAudVol']);
        // position 470;
        $configArr .= sprintf("%02x", $this->config['audio']['prjSignalSrc']);
        $val = $this->config['projector']['innerPcSerialChnn'] & 3;
        $val += ($this->config['projector']['ext1SerialChnn'] & 3) << 2;
        $val += ($this->config['projector']['ext2SerialChnn'] & 3) << 4;
        $val += ($this->config['projector']['localVideoSerialChnn'] & 3) << 6;
        $configArr .= sprintf("%02x", $val);
        $configArr .= sprintf("%02x", $this->config['audio']['mainAudGain']);
        $configArr .= sprintf("%02x", $this->config['audio']['mainAudBass']);
        $configArr .= sprintf("%02x", $this->config['audio']['mainAudTreble']);
        $configArr .= sprintf("%02x", $this->config['audio']['micAudGain']);
        $configArr .= sprintf("%02x", $this->config['audio']['micAudBass']);
        $configArr .= sprintf("%02x", $this->config['audio']['micAudTreble']);
        $configArr .= sprintf("%02x", $this->config['audio']['broadcastVol']);

        //position 479
        $val = ($this->config['system']['buildInHDMIAudio'] ^ 1) & 1;;
        $val += ($this->config['system']['brightEnFlag'] & 1) << 1;
        $val += ($this->config['audio']['dspEnFlag'] & 1) << 2;
        $val += ($this->config['audio']['micEnhanceSrc'] & 3) << 5;
        $val += ($this->config['audio']['pantomPowerMic1On'] & 1) << 3;
        $val += ($this->config['audio']['pantomPowerMic2On'] & 1) << 4;
        $val += ($this->config['system']['presetHDMIRatio'] & 1) << 7;
        $configArr .= sprintf("%02x", $val);

        $configArr .= $this->formatInt($this->optional, 2);
        Yii::$app->base->baseGet(Common::BASEINFO_SECOND_PROJECTOR_SUPPORT, $des, $val);
        if($val !== 1)
            $this->config['projector2']['name'] = '';
        if ($this->optional & 1) {
            //第二路投影什么配置
            $configArr .= $this->formatInt($this->config['projector2']['screenDelay'], 4);
            $configArr .= $this->formatInt($this->config['projector2']['powerOffDelay'], 4);
            $mod = iconv('UTF-8', 'GBK', mb_strcut($this->config['projector2']['name'], 0, 64));
            $configArr .= $this->formatString($mod, 64);
            $configArr .= $this->formatInt($this->config['projector2']['verifySerialOddEven'], 1);
            $configArr .= $this->formatInt($this->config['projector2']['sendTimes'], 1);
            $configArr .= $this->formatInt($this->config['projector2']['sendInterval'], 1);
            $configArr .= $this->formatInt($this->config['projector2']['baudRate'], 1);
            $configArr .= $this->formatInt(strlen($this->config['projector2']['openCode']) >> 1, 1);
            $configArr .= $this->formatString($this->config['projector2']['openCode'], 126, true, false);
            $configArr .= $this->formatInt(strlen($this->config['projector2']['closeCode']) >> 1, 1);
            $configArr .= $this->formatString($this->config['projector2']['closeCode'], 126, true, false);
            $configArr .= $this->formatInt(strlen($this->config['projector2']['chnn2Code']) >> 1, 1);
            $configArr .= $this->formatString($this->config['projector2']['chnn2Code'], 126, true, false);
            $configArr .= $this->formatInt(strlen($this->config['projector2']['chnn1Code']) >> 1, 1);
            $configArr .= $this->formatString($this->config['projector2']['chnn1Code'], 126, true, false);
            $val = ($this->config['projector']['innerPcSerialChnn'] & 3);
            $val += ($this->config['projector']['ext1SerialChnn'] & 3) << 2;
            $val += ($this->config['projector']['ext2SerialChnn'] & 3) << 4;
            $val += ($this->config['projector']['localVideoSerialChnn'] & 3) << 6;
            $configArr .= $this->formatInt($val, 1);
            $configArr .= $this->formatInt(0, 1);
        }
        if($this->optional & 2) {
            $configArr .= $this->formatString($this->config['pclinkCfg']['ip'], 32);
            $configArr .= $this->formatString($this->config['pclinkCfg']['mac'], 32);
            $configArr .= $this->formatInt($this->config['pclinkCfg']['linkFlag'], 1);
            $configArr .= '00';
        }
        if($this->optional & 4) {
            $cfg = $this->config['vlan'];
            if(!empty($cfg)) {
                $configArr .= $this->formatInt(count($cfg['config']), 1);
                $configArr .= $this->formatInt($cfg['TrunkPort'], 1);
                foreach ($cfg['config'] as $c) {
                    $configArr .= $this->formatInt($c['id'], 2);
                    $portmask = $c['sfp'] |
                        ($c['port1'] << 1) | ($c['port2'] << 2) | ($c['port3'] << 3) |
                        ($c['port4'] << 4) | ($c['port5'] << 5) | ($c['port6'] << 6) |
                        ($c['portCentrolController'] << 7) | ($c['portPc'] << 8);
                    $configArr .= $this->formatInt($portmask, 2);
                }
            }
        }
        if($this->optional & 8) {
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['extPwrDelay'], 2);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['eleLockDelay'], 2);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['cp02lcdDelay'], 2);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['clockLinkSys'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['extPwrLinkBrd'], 1);
            //RF
            $rfopencfg = $this->config['sysAdvCfg']['rfDevOpenLink'];
            $rfclosecfg = $this->config['sysAdvCfg']['rfDevCloseLink'];
            $cp02Disablecfg = $this->config['sysAdvCfg']['cp02rfDisableFlag'];
            $open = 0;
            $close = 0;
            $cp02Disable = 0;
            $openDelay = [];
            $closeDelay = [];
            for($j = 0; $j <16; $j++) {
                $openDelay[] = '00';
                $closeDelay[] = '00';
            }
            if(!empty($rfopencfg) && is_array($rfopencfg) ) {
                foreach ($rfopencfg as $c) {
                    if (!array_key_exists('id', $c) || !is_numeric($c['id']) || $c['id'] < 0 || $c['id'] > 16)
                        continue;
                    $open += (1 << $c['id']);
                    $openDelay[$c['id']] = $this->formatInt($c['delay'], 1);
                }
            }
            if(!empty($rfclosecfg) && is_array($rfclosecfg) ) {
                foreach ($rfclosecfg as $c) {
                    $close += (1 << $c['id']);
                    $closeDelay[$c['id']] = $this->formatInt($c['delay'], 1);
                }
            }
            if(!empty($cp02Disablecfg) && is_array($cp02Disablecfg) ) {
                foreach ($cp02Disablecfg as $c) {
                    $cp02Disable += (1 << $c['id']);
                }
            }
            $configArr .= $this->formatInt($open, 2);
            $configArr .= $this->formatInt($close, 2);
            $configArr .= implode('', $openDelay);
            $configArr .= implode('', $closeDelay);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['preSignalSrc'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['cp02PrjCtrl'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['icPowerOffDelay'], 2);
            $configArr .= "00";
            $configArr .= "00";
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['audSwitchEnFlag'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['linkPwrType'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['elelockLevel'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['igmpVer'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['ampType'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['videoInput1Type'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['videoInput2Type'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['videoInput3Type'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['videoOutPut1Type'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['videoOutPut2Type'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['mainDispInfoType'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['secDispInfoType'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['cp01RfCtrlFlag'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['prjAlarmDis'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['prj2CtrlIntfType'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['extComCtrlType'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['usb2SerialCtrlType'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['langDis'], 1);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['pwrOffLockTime'], 1);
            $configArr .= $this->formatString(iconv('UTF-8', 'GBK', $this->config['sysAdvCfg']['phone']), 16);
            $configArr .= $this->formatInt($cp02Disable, 2);
            $configArr .= $this->formatInt($this->config['sysAdvCfg']['micStubEn'], 1);
            $lcdRfCtrl = $this->config['sysAdvCfg']['cp02rfDisableFlag'];
            $lcdRf = 0;
            if(!empty( $lcdRfCtrl) && is_array($lcdRfCtrl)){
                foreach ($lcdRfCtrl as $id){
                    $lcdRf += (1 << $id['id']);
                }
            }
            $configArr .= $this->formatInt($lcdRf, 2);
            $has_opt4 = true;
        }

        return $configArr;
    }

    public static function readConfig($id)
    {
        $device = DeviceList::findOne(['DevID' => $id]);
        if (is_null($device))
            return NULL;
        $dev_cfg = null;

        $protocol = $device->Proto;

        if ($protocol === 3) {
            $dev_cfg = $device->Dev_ConfigurationV2;
            $device->Dev_ConfigurationV2 = NULL;
        } else {
            $dev_cfg = $device->Dev_Configuration;
            $device->Dev_Configuration = NULL;
        }
        $device->save();
        $cnt = 10;
        while($cnt > 0) {
            $ret = Yii::$app->sendcmd2cmpn->sendGetCmd('GetConfig', $id);
            if(!$ret || $ret->errCode != 0){
                return null;
            }
            usleep(200000);
            $device = DeviceList::findOne(['DevID' => $id]);
            if (!is_null($device)) {
                if ($protocol === 3) {
                    if (!is_null($device->Dev_ConfigurationV2))
                        break;
                } else {
                    if (!is_null($device->Dev_Configuration))
                        break;
                }
            }
            $cnt--;
        }
        if($cnt == 0) {
            if(!empty($device)) {
                if ($protocol=== 3) {
                    $device->Dev_ConfigurationV2 = $dev_cfg;
                } else {
                    $device->Dev_Configuration = $dev_cfg;
                }
                $device->save();
            }
            return null;
        }
        $config = new DeviceConfig();
        $config->id = $device->DevID;
        $config->rtspUrl = preg_replace('/rtsp:\/\/(\w+):(\w+)@/i', 'rtsp://***:***@', $device->RtspUrl);
        $config->rtspUrl1 = preg_replace('/rtsp:\/\/(\w+):(\w+)@/i', 'rtsp://***:***@', $device->RtspUrl1);
        $config->rtspSub = preg_replace('/rtsp:\/\/(\w+):(\w+)@/i', 'rtsp://***:***@', $device->RtspSub);
        $config->rtspSub1 = preg_replace('/rtsp:\/\/(\w+):(\w+)@/i', 'rtsp://***:***@', $device->RtspSub1);
        $config->ProjWatermark = $device->ProjWatermark;
        $config->ProjUsedTime = $device->ProjUsedTime;
        $uuid = Yii::$app->base->uuid;
        $identify = "u=$uuid&i=" . $device->DevID;
        $config->MaintainQrcode = 'https://' . Yii::$app->base->getCloudServer() . "/s/oq?$identify";
        $config->pcIp = $device->PcIp;
        $config->pcPort = $device->PcPort;
        $config->pcMainPasswd = empty($device->PcMainPasswd) ? "" : "***";
        $config->pcViewPasswd = empty($device->PcViewPasswd) ? "" : "***";
        $config->RfInvalid = isset($device->RfInvalid) ? $device->RfInvalid : 0;

        // 扩展内容: 录播地址 & 场景
        $extModel = DeviceExt::find()->where(['DevID' => $id])->all();
        foreach ($extModel as $mod) {
            // 场景
            if ($mod->Name === 'SceneCfg')
                $config->scenes = json_decode($mod->Config, true)['value'];
            if ($mod->Name === 'RecorderUrl')
                $config->recUrl = json_decode($mod->Config, true);
        }

        if ($protocol === 3) {
            $config->setScenario('v3');
            $confV2 = str_replace(["\n", ",}", ',]'], ['', '}', ']'], $device->Dev_ConfigurationV2);
            $config->config = json_decode($confV2);
            $config->name = $device->Dev_Name;
            $config->location = iconv('GBK', 'UTF-8', $device->Dev_Description);
            return $config;
        }

        // 录播配置
        $rec_model = DeviceExt::findOne(['DevID' => $id, 'Name' => 'RecorderCfg']);
        if ($rec_model) {
            if (!empty($rec_model->Config))
                $config->config['recoderCfg'] = json_decode($rec_model->Config);
            else
                $config->config['recoderCfg'] = [
                    'rec_type' => '',
                    "cmd_open" => '',
                    "cmd_close" => '',
                    "cmd_start" => '',
                    "cmd_stop" => '',
                    "cmd_pause" => '',
                    "cmd_resume" => '',
                    "recenflag" => 0,
                    "check_bit" => 0,
                    "stop_bit" => 0,
                    "data_bit" => 0,
                    "baud_rate" => 0,
                    "pwrlinkage" => '',
                ];
        }
        if(empty($device->Dev_Configuration) || strlen($device->Dev_Configuration) < 480)
            return $config;
        $configArr = $device->Dev_Configuration;
        //0-131共132字节为设备配置字段
        for ($i = 0; $i < 32; $i++) {
            if (bin2hex($configArr[$i]) == '00')
                break;
        }
        $config->name = iconv('GBK', 'UTF-8', substr($configArr, 0, $i));
        if (is_null($config->name))
            $config->name = $device->Dev_Name;
        for ($i = 32; $i < 128; $i++) {
            if (bin2hex($configArr[$i]) == '00')
                break;
        }
        $config->location = iconv('GBK', 'UTF-8', substr($configArr, 32, $i - 32));
        if (is_null($config->location))
            $config->location= $device->Dev_Description;
        $i = 128;
        $val = hexdec(bin2hex($configArr[$i++]));
        $config->config['system']['enable'] = $val & 0x0f;
        $config->config['system']['deviceStartType'] = ($val >> 4);
        $val = hexdec(bin2hex($configArr[$i++]));
        $config->config['system']['AngBrdEnable'] = $val & 0x01;
        $config->config['audio']['wireMic1Gain'] = ($val >> 2) & 0x07;
        $config->config['audio']['wireMic2Gain'] = ($val >> 5) & 0x07;
        $val = hexdec(bin2hex($configArr[$i++]));
        $config->config['system']['deviceLinkProjector'] = ($val >> 4) & 0x01;
        $config->config['system']['deviceLinkComputer'] = ($val >> 5) & 0x01;
        $config->config['system']['deviceLinkMic'] = ($val >> 6) & 0x01;
        $config->config['system']['deviceLinkProjector2'] = ($val >> 7) & 0x01;
        $config->config['system']['HDMIRatioType'] = hexdec(bin2hex($configArr[$i++]));
        $i = 132;
        //132-467共336字节为视频配置字段
        $config->config['system']['audoDectDelay'] = self::readInt($configArr, 4, $i);
        $config->config['projector']['screenDelay'] = self::readInt($configArr, 4, $i);
        $config->config['projector']['powerOffDelay'] = self::readInt($configArr, 4, $i);
        for ($j = 0; $j < 64; $j++) {
            if (bin2hex($configArr[$i + $j]) == '00')
                break;
        }
        $config->config['projector']['name'] = iconv('GBK', 'UTF-8', substr($configArr, $i, $j));
        $i += 64;
        $config->config['projector']['verifySerialOddEven'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['projector']['sendTimes'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['projector']['sendInterval'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['projector']['baudRate'] = hexdec(bin2hex($configArr[$i++]));
        $len = hexdec(bin2hex($configArr[$i++]));
        $config->config['projector']['openCode'] = strtoupper(bin2hex(substr($configArr, $i, $len)));
        $i += 63;
        $len = hexdec(bin2hex($configArr[$i++]));
        $config->config['projector']['closeCode'] = strtoupper(bin2hex(substr($configArr, $i, $len)));
        $i += 63;
        $len = hexdec(bin2hex($configArr[$i++]));
        $config->config['projector']['chnn2Code'] = strtoupper(bin2hex(substr($configArr, $i, $len)));
        $i += 63;
        $len = hexdec(bin2hex($configArr[$i++]));
        $config->config['projector']['chnn1Code'] = strtoupper(bin2hex(substr($configArr, $i, $len)));
        $i = 468;
        //468-478为音频配置字段
        $config->config['audio']['mainAudVol'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['audio']['micAudVol'] = hexdec(bin2hex($configArr[$i++]));
        if ($config->config['audio']['mainAudVol'] > 63) {
            $config->config['audio']['keepAudConfig'] = 1;
            $config->config['audio']['mainAudVol'] = 0;
        } else {
            $config->config['audio']['keepAudConfig'] = 0;
        }
        if ($config->config['audio']['micAudVol'] > 63) {
            $config->config['audio']['keepMicConfig'] = 1;
            $config->config['audio']['micAudVol'] = 0;
        } else {
            $config->config['audio']['keepMicConfig'] = 0;
        }
        $config->config['audio']['prjSignalSrc'] = hexdec(bin2hex($configArr[$i++]));
        $val = hexdec(bin2hex($configArr[$i++]));
        $config->config['projector']['innerPcSerialChnn'] = $val & 0x01;
        $config->config['projector']['ext1SerialChnn'] = ($val >> 2) & 0x03;
        $config->config['projector']['ext2SerialChnn'] = ($val >> 4) & 0x03;
        $config->config['projector']['localVideoSerialChnn'] = ($val >> 6) & 0x03;
        $config->config['audio']['mainAudGain'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['audio']['mainAudBass'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['audio']['mainAudTreble'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['audio']['micAudGain'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['audio']['micAudBass'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['audio']['micAudTreble'] = hexdec(bin2hex($configArr[$i++]));
        $config->config['audio']['broadcastVol'] = hexdec(bin2hex($configArr[$i++]));
        $i = 479;
        //479为设备配置字段
        $val = hexdec(bin2hex($configArr[$i]));
        $config->config['system']['buildInHDMIAudio'] = ($val ^ 1) & 0x01;
        $config->config['system']['brightEnFlag'] = ($val >> 1) & 0x01;
        $config->config['audio']['dspEnFlag'] = ($val >> 2) & 0x01;
        $config->config['audio']['micEnhanceSrc'] = ($val >> 5) & 0x03;
        $config->config['audio']['pantomPowerMic1On'] = ($val >> 3) & 0x01;
        $config->config['audio']['pantomPowerMic2On']= ($val >> 4) & 0x01;
        $config->config['system']['presetHDMIRatio'] = ($val >> 7) & 0x01;
        $i++;
        $configLen = strlen($configArr);
        if ($configLen < 480) {
            $config->optional  = 0;
            // tm-03
            unset($config->config);
            $config->config = $device->Dev_ConfigurationV2;
            return $config;
        }

        if ($configLen == 480) {
            $config->optional = 0;
            return $config;
        }

        /*480之后为高级配置*/
        $config->optional = self::readInt($configArr, 2, $i);
        do {
            // 第二路投影机配置
            if ($config->optional & 0x01) {
                if(strlen($configArr) < $i + 334)
                    break;
                $config->config['projector2']['screenDelay'] = self::readInt($configArr, 4, $i);
                $config->config['projector2']['powerOffDelay'] = self::readInt($configArr, 4, $i);
                for ($j = 0; $j < 64; $j++) {
                    if (bin2hex($configArr[$i + $j]) == '00')
                        break;
                }
                $config->config['projector2']['name'] = trim(iconv('GBK', 'UTF-8', substr($configArr, $i, $j)));
                $i += 64;
                $config->config['projector2']['verifySerialOddEven'] = self::readInt($configArr, 1, $i);
                $config->config['projector2']['sendTimes'] = self::readInt($configArr, 1, $i);
                $config->config['projector2']['sendInterval'] = self::readInt($configArr, 1, $i);
                $config->config['projector2']['baudRate'] = self::readInt($configArr, 1, $i);
                $len = hexdec(bin2hex($configArr[$i++]));
                $config->config['projector2']['openCode'] = strtoupper(bin2hex(substr($configArr, $i, $len)));
                $i += 63;
                $len = hexdec(bin2hex($configArr[$i++]));
                $config->config['projector2']['closeCode'] = strtoupper(bin2hex(substr($configArr, $i, $len)));
                $i += 63;
                $len = hexdec(bin2hex($configArr[$i++]));
                $config->config['projector2']['chnn2Code'] = strtoupper(bin2hex(substr($configArr, $i, $len)));
                $i += 63;
                $len = hexdec(bin2hex($configArr[$i++]));
                $config->config['projector2']['chnn1Code'] = strtoupper(bin2hex(substr($configArr, $i, $len)));
                $i += 63;
                $val = self::readInt($configArr, 1, $i);
                $config->config['projector2']['innerPcSerialChnn'] = 0;
                $config->config['projector2']['ext1SerialChnn'] = 0;
                $config->config['projector2']['ext2SerialChnn'] = 0;
                $config->config['projector2']['localVideoSerialChnn'] = 0;
                $i++;
            }

            if($config->optional & 0x02) {
                if(strlen($configArr) < $i + 66)
                    break;
                $config->config['pclinkCfg']['ip'] = trim(substr($configArr, $i, 32));
                $i += 32;
                $config->config['pclinkCfg']['mac'] =  trim(substr($configArr, $i, 32));
                $i += 32;
                $config->config['pclinkCfg']['linkFlag'] = (hexdec(bin2hex($configArr[$i++])) & 1);
                $i++;
            }
            if($config->optional & 0x04){
                if(strlen($configArr) < $i + 1)
                    break;
                $sum = self::readInt($configArr, 1, $i);
                if(strlen($configArr) < $i + $sum * 4)
                    break;
                $cfg = [];
                $trunkport = self::readInt($configArr, 1, $i);
                for($j = 0; $j < $sum; $j++) {
                    $id = self::readInt($configArr, 2, $i);
                    $portmask = self::readInt($configArr, 2, $i);

                    $cfg[] = [
                        'id' => $id, 'sfp' => $portmask & 0x01,
                        'port1' => ($portmask >> 1) & 0x01, 'port2' => ($portmask >> 2) & 0x01, 'port3' => ($portmask >> 3) & 0x01,
                        'port4' => ($portmask >> 4) & 0x01, 'port5' => ($portmask >> 5) & 0x01, 'port6' => ($portmask >> 6) & 0x01,
                        'portCentrolController' => ($portmask >> 7) & 0x01,
                        'portPc' => ($portmask >> 8) & 0x01,
                    ];
                }
                $config->config['vlan'] = ['TrunkPort' => $trunkport, 'config' => $cfg];
            }
            if($config->optional & 0x08){
                if(strlen($configArr) < $i + 256)
                    break;
                $config->config['sysAdvCfg']['extPwrDelay'] = self::readInt($configArr, 2, $i);
                $config->config['sysAdvCfg']['eleLockDelay'] = self::readInt($configArr, 2, $i);
                $config->config['sysAdvCfg']['cp02lcdDelay'] = self::readInt($configArr, 2, $i);
                $config->config['sysAdvCfg']['clockLinkSys'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['extPwrLinkBrd'] = self::readInt($configArr, 1, $i);
                $RfDevOpenLink = self::readInt($configArr, 2, $i);
                $RfDevCloseLink = self::readInt($configArr, 2, $i);
                for($j = 0; $j < 16; $j++) {
                    $openDelay = hexdec(bin2hex($configArr[$i]));
                    $closeDelay = hexdec(bin2hex($configArr[$i++ + 16]));
                    $open = (($RfDevOpenLink >> $j) & 1);
                    $close = (($RfDevCloseLink >> $j) & 1);
                    if($open) {
                        $config->config['sysAdvCfg']['rfDevOpenLink'][] = [
                            'id' => $j,
                            'delay' => $openDelay,
                        ];
                    }
                    if($close){
                        $config->config['sysAdvCfg']['rfDevCloseLink'][] = [
                            'id' => $j,
                            'delay' => $closeDelay,
                        ];
                    }
                }
                $i += 16;
                $config->config['sysAdvCfg']['preSignalSrc'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['cp02PrjCtrl'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['icPowerOffDelay'] = self::readInt($configArr, 2, $i);
                $i += 2;
                $config->config['sysAdvCfg']['audSwitchEnFlag'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['linkPwrType'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['elelockLevel'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['igmpVer'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['ampType'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['videoInput1Type'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['videoInput2Type'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['videoInput3Type'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['videoOutPut1Type'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['videoOutPut2Type'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['mainDispInfoType'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['secDispInfoType'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['cp01RfCtrlFlag'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['prjAlarmDis'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['prj2CtrlIntfType'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['extComCtrlType'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['usb2SerialCtrlType'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['langDis'] = self::readInt($configArr, 1, $i);
                $config->config['sysAdvCfg']['pwrOffLockTime'] = self::readInt($configArr, 1, $i);
                $j = 0;
                for (; $j < 16; $j++) {
                    if (bin2hex($configArr[$i + $j]) == '00') break;
                }

                $config->config['sysAdvCfg']['phone'] = iconv('GBK', 'UTF-8', substr($configArr, $i, $j));
                $i += 16;
                $Cp02rfDisableFlag = self::readInt($configArr, 2, $i);
                for ($j=0; $j<16; $j++) {
                    $cp02Disable = (($Cp02rfDisableFlag >> $j) & 1);
                    if($cp02Disable)
                        $config->config['sysAdvCfg']['cp02rfDisableFlag'][] = ['id'=>$j];
                }
                $config->config['sysAdvCfg']['micStubEn'] = self::readInt($configArr, 1, $i);
                $RfLcdCtrl = self::readInt($configArr, 2, $i);
                for($j=0; $j < 16; $j++){
                    $en = (($RfLcdCtrl >> $j) & 1);
                    if($en)
                        $config->config['sysAdvCfg']['lcdRfCtrl'][] = ['id'=>$j];
                }
            }
        }while(false);

        return $config;
    }

    public function fields()
    {
        $fields = parent::fields(); // TODO: Change the autogenerated stub
        if ($this->getScenario() == 'v3') {
            unset($fields['config']);
            return ['MaintainQrcode', 'config', 'ProjUsedTime', 'ProjWatermark', 'id', 'name', 'location',
                'pcIp', 'pcMainPasswd', 'pcPort', 'pcViewPasswd',
                'rtspUrl', 'rtspUrl1', 'rtspSub', 'rtspSub1', 'RfInvalid', 'recUrl', 'scenes'];
        }
        else {
            return ['MaintainQrcode', 'config', 'ProjUsedTime', 'ProjWatermark', 'id', 'name', 'location',
                'pcIp', 'pcMainPasswd', 'pcPort', 'pcViewPasswd',
                'rtspUrl', 'rtspUrl1', 'rtspSub', 'rtspSub1', 'RfInvalid', 'recUrl', 'scenes'];
        }
    }
}
