<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "DeviceExt".
 *
 * @property string $DevID
 * @property string $Name
 * @property string $Config
 *
 * @property DeviceList $dev
 */
class DeviceExt extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'DeviceExt';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['DevID', 'Name'], 'required'],
            [['DevID'], 'string', 'max' => 50],
            [['Name'], 'string', 'max' => 45],
            [['Config'], 'string', 'max' => 2048],
            [['DevID', 'Name'], 'unique', 'targetAttribute' => ['DevID', 'Name'], 'message' => 'The combination of Dev ID and Name has already been taken.'],
            [['DevID'], 'exist', 'skipOnError' => true, 'targetClass' => DeviceList::className(), 'targetAttribute' => ['DevID' => 'DevID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'DevID' => 'Dev ID',
            'Name' => 'Name',
            'Config' => 'Config',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getDev()
    {
        return $this->hasOne(DeviceList::className(), ['DevID' => 'DevID']);
    }
}
