<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "Event".
 *
 * @property integer $Id
 * @property string $Name
 * @property integer $StartTask
 * @property integer $EndTask
 * @property resource $Config
 * @property integer $Model
 * @property integer $Version
 *
 * @property EventModel $model
 */
class Event extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'Event';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['Name', 'Config', 'Model'], 'required'],
            [['StartTask', 'EndTask', 'Model', 'Version'], 'integer'],
            [['Name'], 'string', 'max' => 31],
            [['Config'], 'string', 'max' => 66],
            [['Model'], 'exist', 'skipOnError' => true, 'targetClass' => EventModel::className(), 'targetAttribute' => ['Model' => 'id']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'Id' => 'ID',
            'Name' => 'Name',
            'StartTask' => 'Start Task',
            'EndTask' => 'End Task',
            'Config' => 'Config',
            'Model' => 'Model',
            'Version' => 'Version',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getModel()
    {
        return $this->hasOne(EventModel::className(), ['id' => 'Model']);
    }
}
