<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "EventModel".
 *
 * @property integer $id
 * @property string $Manufacturer
 * @property string $Model
 * @property integer $Magic
 *
 * @property Event[] $events
 */
class EventModel extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'EventModel';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['Manufacturer', 'Model', 'Magic'], 'required'],
            [['Magic'], 'integer'],
            [['Manufacturer', 'Model'], 'string', 'max' => 31],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'Manufacturer' => 'Manufacturer',
            'Model' => 'Model',
            'Magic' => 'Magic',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getEvents()
    {
        return $this->hasMany(Event::className(), ['Model' => 'id']);
    }
}
