<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "IpCall".
 *
 * @property integer $id
 * @property string $device
 * @property integer $waiter
 * @property integer $audioPort
 * @property string $ringing
 * @property string $status
 * @property string $direction
 * @property string $webrtcUpdate
 * @property string $webrtcStatus
 * @property integer $wsPort
 * @property integer $listen
 */
class IpCall extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'IpCall';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['waiter', 'audioPort', 'wsPort', 'listen'], 'integer'],
            [['ringing', 'webrtcUpdate'], 'safe'],
            [['status', 'direction', 'webrtcStatus'], 'string'],
            [['device'], 'string', 'max' => 45],
            [['audioPort'], 'unique'],
            [['wsPort'], 'unique'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'device' => 'Device',
            'waiter' => 'Waiter',
            'audioPort' => 'Audio Port',
            'ringing' => 'Ringing',
            'status' => 'Status',
            'direction' => 'Direction',
            'webrtcUpdate' => 'Webrtc Update',
            'webrtcStatus' => 'Webrtc Status',
            'wsPort' => 'Ws Port',
            'listen' => 'Listen',
        ];
    }
}
