<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "NotificationMsg".
 *
 * @property integer $id
 * @property integer $uid
 * @property string $type
 * @property string $time
 * @property string $ipaddress
 * @property string $description
 * @property string $update_at
 * @property integer $handle_uid
 * @property string $status
 */
class NotificationMsg extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'NotificationMsg';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['uid', 'type', 'description'], 'required'],
            [['uid', 'handle_uid'], 'integer'],
            [['time', 'update_at'], 'safe'],
            [['status'], 'string'],
            [['type'], 'string', 'max' => 32],
            [['ipaddress'], 'string', 'max' => 45],
            [['description'], 'string', 'max' => 4096],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'uid' => 'Uid',
            'type' => 'Type',
            'time' => 'Time',
            'ipaddress' => 'Ipaddress',
            'description' => 'Description',
            'update_at' => 'Update At',
            'handle_uid' => 'Handle Uid',
            'status' => 'Status',
        ];
    }
}
