<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "PlayListFiles".
 *
 * @property integer $PlayListFIleId
 * @property integer $FileID
 * @property integer $SequenceID
 * @property integer $SessionID
 * @property integer $Duration
 * @property integer $KeyIndex
 * @property string $PlayerID
 *
 * @property MediaFiles $file
 * @property PlaySessions $session
 */
class PlayListFiles extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'PlayListFiles';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['FileID', 'SequenceID', 'SessionID', 'Duration', 'KeyIndex'], 'integer'],
            [['SequenceID', 'SessionID'], 'required'],
            [['PlayerID'], 'string', 'max' => 50],
            [['SessionID', 'SequenceID'], 'unique', 'targetAttribute' => ['SessionID', 'SequenceID'], 'message' => 'The combination of Sequence ID and Session ID has already been taken.'],
            [['FileID'], 'exist', 'skipOnError' => true, 'targetClass' => MediaFiles::className(), 'targetAttribute' => ['FileID' => 'MediaID']],
            [['SessionID'], 'exist', 'skipOnError' => true, 'targetClass' => PlaySessions::className(), 'targetAttribute' => ['SessionID' => 'SessionID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'PlayListFIleId' => 'Play List File ID',
            'FileID' => 'File ID',
            'SequenceID' => 'Sequence ID',
            'SessionID' => 'Session ID',
            'Duration' => 'Duration',
            'KeyIndex' => 'Key Index',
            'PlayerID' => 'Player ID',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getFile()
    {
        return $this->hasOne(MediaFiles::className(), ['MediaID' => 'FileID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getSession()
    {
        return $this->hasOne(PlaySessions::className(), ['SessionID' => 'SessionID']);
    }
}
