<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "PlayerKeys".
 *
 * @property integer $PlayerKeyId
 * @property string $PlayerID
 * @property integer $Index
 * @property integer $GroupDisable
 * @property integer $DevDisable
 * @property integer $GroupID
 *
 * @property DevClasses $group
 * @property Players $player
 */
class PlayerKeys extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'PlayerKeys';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['PlayerID', 'Index'], 'required'],
            [['Index', 'GroupDisable', 'DevDisable', 'GroupID'], 'integer'],
            [['PlayerID'], 'string', 'max' => 50],
            [['PlayerID', 'Index'], 'unique', 'targetAttribute' => ['PlayerID', 'Index'], 'message' => 'The combination of Player ID and Index has already been taken.'],
            [['GroupID'], 'exist', 'skipOnError' => true, 'targetClass' => DevClasses::className(), 'targetAttribute' => ['GroupID' => 'ClassID']],
            [['PlayerID'], 'exist', 'skipOnError' => true, 'targetClass' => Players::className(), 'targetAttribute' => ['PlayerID' => 'PlayerID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'PlayerKeyId' => 'Player Key ID',
            'PlayerID' => 'Player ID',
            'Index' => 'Index',
            'GroupDisable' => 'Group Disable',
            'DevDisable' => 'Dev Disable',
            'GroupID' => 'Group ID',
        ];
    }

    public function fields()
    {
        $ret = parent::fields(); // TODO: Change the autogenerated stub
        if(!$ret)
            return $ret;
        unset($ret['PlayerKeyId'], $ret['GroupDisable'], $ret['DevDisable']);
        return $ret;
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getGroup()
    {
        return $this->hasOne(DevClasses::className(), ['ClassID' => 'GroupID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPlayer()
    {
        return $this->hasOne(Players::className(), ['PlayerID' => 'PlayerID']);
    }
}
