<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "Players".
 *
 * @property string $PlayerID
 * @property resource $PlayerName
 * @property integer $PlayerType
 * @property integer $Priority
 * @property resource $Remark
 *
 * @property PlaySessions[] $playSessions
 * @property PlayerKeys[] $playerKeys
 * @property Users $users
 */
class Players extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'Players';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['PlayerID'], 'required'],
            [['PlayerType', 'Priority'], 'integer'],
            [['PlayerID'], 'string', 'max' => 50],
            [['PlayerName'], 'string', 'max' => 32],
            [['Remark'], 'string', 'max' => 96],
            [['PlayerID'], 'unique'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'PlayerID' => 'Player ID',
            'PlayerName' => 'Player Name',
            'PlayerType' => 'Player Type',
            'Priority' => 'Priority',
            'Remark' => 'Remark',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPlaySessions()
    {
        return $this->hasMany(PlaySessions::className(), ['PlayerID' => 'PlayerID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPlayerKeys()
    {
        return $this->hasMany(PlayerKeys::className(), ['PlayerID' => 'PlayerID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUsers()
    {
        return $this->hasOne(Users::className(), ['UsbKey' => 'PlayerID']);
    }
}
