<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "ProjectorType".
 *
 * @property string $Type
 * @property integer $PoweroffDelay
 * @property integer $CheckBit
 * @property integer $StopBit
 * @property integer $DataBit
 * @property integer $BaudRate
 * @property string $CmdOpen
 * @property string $CmdClose
 * @property string $CmdFromPc
 * @property string $CmdFromVideo
 */
class ProjectorType extends \yii\db\ActiveRecord
{
    const CHECK_BIT = ['none','even','odd'];
    const DATA_BIT = ['8','7','6','5'];
    const STOP_BIT = ['1', '1.5','2'];
    const BAUD_RATE = ['300', '600', '1200', '2400', '4800', '9600', '19200', '38400', '43000', '56000', '57600', '115200'];
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'ProjectorType';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['Type', 'PoweroffDelay', 'CheckBit', 'StopBit', 'DataBit', 'BaudRate', 'CmdOpen', 'CmdClose', 'CmdFromPc', 'CmdFromVideo'], 'required'],
            [['PoweroffDelay', 'CheckBit', 'StopBit', 'DataBit', 'BaudRate'], 'integer'],
            [['Type'], 'string', 'max' => 50],
            [['CmdOpen', 'CmdClose', 'CmdFromPc', 'CmdFromVideo'], 'string', 'max' => 255],
            [['Type'], 'unique'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'Type' => 'Type',
            'PoweroffDelay' => 'Poweroff Delay',
            'CheckBit' => 'Check Bit',
            'StopBit' => 'Stop Bit',
            'DataBit' => 'Data Bit',
            'BaudRate' => 'Baud Rate',
            'CmdOpen' => 'Cmd Open',
            'CmdClose' => 'Cmd Close',
            'CmdFromPc' => 'Cmd From Pc',
            'CmdFromVideo' => 'Cmd From Video',
        ];
    }
}
