<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "SectionTable".
 *
 * @property string $zone
 * @property string $name
 * @property string $alias
 * @property string $start
 * @property string $end
 */
class SectionTable extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'SectionTable';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['zone', 'name', 'alias'], 'required'],
            [['start', 'end'], 'safe'],
            [['zone', 'name', 'alias'], 'string', 'max' => 32],
            [['zone', 'name'], 'unique', 'targetAttribute' => ['zone', 'name'], 'message' => 'The combination of Zone and Name has already been taken.'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'zone' => 'Zone',
            'name' => 'Name',
            'alias' => 'Alias',
            'start' => 'Start',
            'end' => 'End',
        ];
    }
}
