<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "SubNetwork".
 *
 * @property integer $idSubNetwork
 * @property string $NetMask
 * @property string $IpAddress
 */
class SubNetwork extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'SubNetwork';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['idSubNetwork'], 'required'],
            [['idSubNetwork'], 'integer'],
            [['NetMask', 'IpAddress'], 'string', 'max' => 50],
            [['idSubNetwork'], 'unique'],
        ];
    }

    public function fields()
    {
        return [
            'id' => 'idSubNetwork',
            'mask' => 'NetMask',
            'ip' => 'IpAddress',
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'idSubNetwork' => 'Id Sub Network',
            'NetMask' => 'Net Mask',
            'IpAddress' => 'Ip Address',
        ];
    }
}
