<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "SystemLog".
 *
 * @property integer $id
 * @property string $at
 * @property string $ip
 * @property integer $result
 * @property string $username
 * @property string $title1
 * @property string $title2
 * @property string $type
 * @property string $action
 * @property string $detail
 * @property string $parameter_detail
 */
class SystemLog extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'SystemLog';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['at'], 'safe'],
            [['result', 'type', 'action'], 'required'],
            [['result'], 'integer'],
            [['ip'], 'string', 'max' => 16],
            [['username', 'title1', 'title2'], 'string', 'max' => 255],
            [['type', 'action'], 'string', 'max' => 64],
            [['detail'], 'string', 'max' => 1024],
            [['parameter_detail'], 'string', 'max'=>4096],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'at' => 'At',
            'ip' => 'Ip',
            'result' => 'Result',
            'username' => 'Username',
            'title1' => 'Title1',
            'title2' => 'Title2',
            'type' => 'Type',
            'action' => 'Action',
            'detail' => 'Detail',
            'parameter_detail'=>'Parameter_detail'
        ];
    }
}
