<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "TaskTemplate".
 *
 * @property integer $idTaskTemplate
 * @property string $TemplateName
 * @property integer $Enabled
 *
 * @property PlaySessions[] $playSessions
 */
class TaskTemplate extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'TaskTemplate';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['Enabled'], 'integer'],
            [['TemplateName'], 'string', 'max' => 45],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'idTaskTemplate' => 'Id Task Template',
            'TemplateName' => 'Template Name',
            'Enabled' => 'Enabled',
        ];
    }

    public function fields()
    {
        $ret = parent::fields(); // TODO: Change the autogenerated stub
        if(empty($ret))
            return $ret;
        unset($ret['Enabled']);
        return $ret;
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPlaySessions()
    {
        return $this->hasMany(PlaySessions::className(), ['Template' => 'idTaskTemplate']);
    }
}
