<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "UserDevices".
 *
 * @property integer $UserDevID
 * @property integer $UserID
 * @property string $DevID
 * @property integer $Pri
 *
 * @property Users $user
 * @property DeviceList $dev
 */
class UserDevices extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'UserDevices';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['UserID', 'DevID'], 'required'],
            [['UserID', 'Pri'], 'integer'],
            [['DevID'], 'string', 'max' => 50],
            [['UserID', 'DevID'], 'unique', 'targetAttribute' => ['UserID', 'DevID'], 'message' => 'The combination of User ID and Dev ID has already been taken.'],
            [['UserID'], 'exist', 'skipOnError' => true, 'targetClass' => Users::className(), 'targetAttribute' => ['UserID' => 'User_ID']],
            [['DevID'], 'exist', 'skipOnError' => true, 'targetClass' => DeviceList::className(), 'targetAttribute' => ['DevID' => 'DevID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'UserDevID' => 'User Dev ID',
            'UserID' => 'User ID',
            'DevID' => 'Dev ID',
            'Pri' => 'Pri',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUser()
    {
        return $this->hasOne(Users::className(), ['User_ID' => 'UserID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getDev()
    {
        return $this->hasOne(DeviceList::className(), ['DevID' => 'DevID']);
    }
}
