<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "DevClasses".
 *
 * @property integer $ClassID
 * @property string $Name
 * @property integer $Parent
 * @property string $DevID
 * @property string $Dev_Name
 *
 * @property DevClasses $parent
 * @property DevClasses[] $devClasses
 * @property DeviceList[] $deviceLists
 * @property GroupCtrlSchedule[] $groupCtrlSchedules
 * @property PlayerKeys[] $playerKeys
 */
class VDevClasses extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'v_device_classes';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['Parent'], 'integer'],
            [['Name'], 'string', 'max' => 50],
            [['DevID'], 'string', 'max' => 50],
            [['Dev_Name'], 'string', 'max' => 32],
            [['Parent'], 'exist', 'skipOnError' => true, 'targetClass' => DevClasses::className(), 'targetAttribute' => ['Parent' => 'ClassID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'ClassID' => 'Class ID',
            'Name' => 'Name',
            'Parent' => 'Parent',
            'DevID' => 'Dev ID',
            'Dev_Name' => 'Dev Name',
        ];
    }
}
