<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "v_ip_call".
 *
 * @property integer $id
 * @property string $device
 * @property string $deviceName
 * @property integer $waiter
 * @property string $waiterName
 * @property integer $audioPort
 * @property string $ringing
 * @property string $status
 * @property string $direction
 * @property string $webrtcUpdate
 * @property string $webrtcStatus
 * @property integer $wsPort
 */
class VIpCall extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'v_ip_call';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'waiter', 'audioPort', 'wsPort'], 'integer'],
            [['ringing', 'webrtcUpdate'], 'safe'],
            [['status', 'direction', 'webrtcStatus'], 'string'],
            [['device'], 'string', 'max' => 45],
            [['deviceName'], 'string', 'max' => 32],
            [['waiterName'], 'string', 'max' => 255],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'device' => 'Device',
            'deviceName' => 'Device Name',
            'waiter' => 'Waiter',
            'waiterName' => 'Waiter Name',
            'audioPort' => 'Audio Port',
            'ringing' => 'Ringing',
            'status' => 'Status',
            'direction' => 'Direction',
            'webrtcUpdate' => 'Webrtc Update',
            'webrtcStatus' => 'Webrtc Status',
            'wsPort' => 'Ws Port',
        ];
    }

    public function fields()
    {
        $fields = parent::fields(); // TODO: Change the autogenerated stub
        unset($fields['webrtcStatus'], $fields['webrtcUpdate'], $fields['waiter']);
        return $fields;
    }
}
