<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "v_media_files".
 *
 * @property integer $MediaID
 * @property string $FileName
 * @property integer $FileSize
 * @property integer $TotalTime
 * @property integer $FileFmt
 * @property integer $BitRate
 * @property integer $VedioCodec
 * @property integer $Height
 * @property integer $Width
 * @property integer $FrameRate
 * @property integer $AudioCodec
 * @property integer $Channels
 * @property integer $SampleRate
 * @property integer $Parent
 * @property integer $Gain
 * @property string $CreateTime
 * @property string $FilePath
 * @property integer $Owner
 * @property string $OwnerName
 * @property integer $Sysfolder
 * @property integer $Check
 */
class VMediaFiles extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'v_media_files';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['MediaID', 'FileSize', 'TotalTime', 'FileFmt', 'BitRate', 'VedioCodec', 'Height', 'Width', 'FrameRate', 'AudioCodec', 'Channels', 'SampleRate', 'Parent', 'Gain', 'Owner', 'Sysfolder', 'Check'], 'integer'],
            [['CreateTime'], 'safe'],
            [['FileName'], 'string', 'max' => 64],
            [['FilePath'], 'string', 'max' => 256],
            [['OwnerName'], 'string', 'max' => 255],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'MediaID' => 'Media ID',
            'FileName' => 'File Name',
            'FileSize' => 'File Size',
            'TotalTime' => 'Total Time',
            'FileFmt' => 'File Fmt',
            'BitRate' => 'Bit Rate',
            'VedioCodec' => 'Vedio Codec',
            'Height' => 'Height',
            'Width' => 'Width',
            'FrameRate' => 'Frame Rate',
            'AudioCodec' => 'Audio Codec',
            'Channels' => 'Channels',
            'SampleRate' => 'Sample Rate',
            'Parent' => 'Parent',
            'Gain' => 'Gain',
            'CreateTime' => 'Create Time',
            'FilePath' => 'File Path',
            'Owner' => 'Owner',
            'OwnerName' => 'Owner Name',
            'Sysfolder' => 'Sysfolder',
            'Check' => 'Check',
        ];
    }
}
