<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "v_notification".
 *
 * @property integer $id
 * @property integer $uid
 * @property string $udesc
 * @property string $uname
 * @property string $type
 * @property string $time
 * @property string $ipaddress
 * @property string $description
 * @property string $update_at
 * @property integer $handle_uid
 * @property string $handle_udesc
 * @property string $handle_uname
 * @property string $status
 */
class VNotification extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'v_notification';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'uid', 'handle_uid'], 'integer'],
            [['uid', 'type', 'description'], 'required'],
            [['time', 'update_at'], 'safe'],
            [['udesc', 'uname', 'handle_udesc', 'handle_uname'], 'string', 'max' => 255],
            [['type'], 'string', 'max' => 32],
            [['ipaddress'], 'string', 'max' => 45],
            [['description'], 'string', 'max' => 4096],
            [['status'], 'string', 'max' => 3],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'uid' => 'Uid',
            'udesc' => 'Udesc',
            'uname' => 'Uname',
            'type' => 'Type',
            'time' => 'Time',
            'ipaddress' => 'Ipaddress',
            'description' => 'Description',
            'update_at' => 'Update At',
            'handle_uid' => 'Handle Uid',
            'handle_udesc' => 'Handle Udesc',
            'handle_uname' => 'Handle Uname',
            'status' => 'Status',
        ];
    }
}
