<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "v_playing_sessions".
 *
 * @property integer $SessionID
 * @property string $PlayerID
 * @property integer $PlayingFileID
 * @property string $FileName
 * @property integer $MultiPort
 * @property integer $CircleLength
 * @property integer $CurrFileProgress
 * @property integer $CurrTotalProgress
 * @property integer $Priority
 * @property integer $Pause
 * @property integer $ScheduleID
 * @property integer $WeekDay
 * @property string $PlayTime
 * @property integer $Template
 * @property integer $BrdMode
 * @property integer $SessionType
 * @property integer $StreamType
 */
class VPlayingSessions extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'v_playing_sessions';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['SessionID'], 'required'],
            [['SessionID', 'PlayingFileID', 'MultiPort', 'CircleLength', 'CurrFileProgress', 'CurrTotalProgress', 'Priority', 'Pause', 'ScheduleID', 'WeekDay', 'Template', 'BrdMode', 'SessionType', 'StreamType'], 'integer'],
            [['PlayTime'], 'safe'],
            [['PlayerID'], 'string', 'max' => 50],
            [['FileName'], 'string', 'max' => 64],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'SessionID' => 'Session ID',
            'PlayerID' => 'Player ID',
            'PlayingFileID' => 'Playing File ID',
            'FileName' => 'File Name',
            'MultiPort' => 'Multi Port',
            'CircleLength' => 'Circle Length',
            'CurrFileProgress' => 'Curr File Progress',
            'CurrTotalProgress' => 'Curr Total Progress',
            'Priority' => 'Priority',
            'Pause' => 'Pause',
            'ScheduleID' => 'Schedule ID',
            'WeekDay' => 'Week Day',
            'PlayTime' => 'Play Time',
            'Template' => 'Template',
            'BrdMode' => 'Brd Mode',
            'SessionType' => 'Session Type',
            'StreamType' => 'Stream Type',
        ];
    }
}
