<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "v_session_info".
 *
 * @property integer $SessionID
 * @property string $SessionName
 * @property integer $SessionType
 * @property integer $Priority
 * @property integer $CircleLength
 * @property string $PlayerID
 * @property integer $BrdMode
 * @property integer $MemberMode
 * @property integer $StreamType
 * @property integer $SysEnabled
 * @property string $RfDevCtrl
 * @property integer $Owner
 * @property string $OwnerName
 * @property integer $PlayMode
 * @property integer $AudioGain
 * @property integer $Template
 * @property integer $FileID
 * @property string $PlayerAddress
 * @property integer $PlayType
 * @property integer $PlayerType
 */
class VSessionInfo extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'v_session_info';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['SessionID', 'SessionType', 'Priority', 'CircleLength', 'BrdMode', 'MemberMode', 'StreamType', 'SysEnabled', 'Owner', 'PlayMode', 'AudioGain', 'Template', 'FileID', 'PlayType', 'PlayerType'], 'integer'],
            [['SessionName'], 'required'],
            [['SessionName', 'PlayerID', 'PlayerAddress'], 'string', 'max' => 50],
            [['RfDevCtrl'], 'string', 'max' => 32],
            [['OwnerName'], 'string', 'max' => 255],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'SessionID' => 'Session ID',
            'SessionName' => 'Session Name',
            'SessionType' => 'Session Type',
            'Priority' => 'Priority',
            'CircleLength' => 'Circle Length',
            'PlayerID' => 'Player ID',
            'BrdMode' => 'Brd Mode',
            'MemberMode' => 'Member Mode',
            'StreamType' => 'Stream Type',
            'SysEnabled' => 'Sys Enabled',
            'RfDevCtrl' => 'Rf Dev Ctrl',
            'Owner' => 'Owner',
            'OwnerName' => 'Owner Name',
            'PlayMode' => 'Play Mode',
            'AudioGain' => 'Audio Gain',
            'Template' => 'Template',
            'FileID' => 'File ID',
            'PlayerAddress' => 'Player Address',
            'PlayType' => 'Play Type',
            'PlayerType' => 'Player Type',
        ];
    }
}
