<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "v_timed_session_info".
 *
 * @property integer $SessionID
 * @property string $SessionName
 * @property integer $SessionType
 * @property integer $Priority
 * @property integer $BrdMode
 * @property string $StreamType
 * @property integer $Owner
 * @property string $PlayMode
 * @property integer $Template
 * @property integer $FileID
 * @property string $PlayTime
 * @property string $WeekDay
 * @property integer $OneTime
 */
class VTimedSessionInfo extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'v_timed_session_info';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['SessionID', 'SessionType', 'Priority', 'BrdMode', 'StreamType', 'Owner', 'Template', 'FileID', 'OneTime'], 'integer'],
            [['PlayTime'], 'safe'],
            [['WeekDay'], 'string'],
            [['SessionName'], 'string', 'max' => 50],
            [['PlayMode'], 'string', 'max' => 4],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'SessionID' => 'Session ID',
            'SessionName' => 'Session Name',
            'SessionType' => 'Session Type',
            'Priority' => 'Priority',
            'BrdMode' => 'Brd Mode',
            'StreamType' => 'Stream Type',
            'Owner' => 'Owner',
            'PlayMode' => 'Play Mode',
            'Template' => 'Template',
            'FileID' => 'File ID',
            'PlayTime' => 'Play Time',
            'WeekDay' => 'Week Day',
            'OneTime' => 'One Time',
        ];
    }
}
