<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "v_timetable_v1".
 *
 * @property integer $ID
 * @property string $Dev_Name
 * @property string $User_Flag
 * @property string $User_Name
 * @property integer $User_ID
 * @property string $User_Desc
 * @property string $Zone
 * @property string $CourseName
 * @property string $TermName
 * @property integer $SectionStart
 * @property integer $SectionEnd
 * @property integer $WeekDay
 * @property integer $WeekStart
 * @property integer $WeekEnd
 * @property string $WeekType
 * @property string $Active
 * @property string $Type
 */
class VTimetableV1 extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'v_timetable_v1';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['ID', 'User_ID', 'SectionStart', 'SectionEnd', 'WeekDay', 'WeekStart', 'WeekEnd'], 'integer'],
            [['Dev_Name', 'User_Flag'], 'required'],
            [['WeekType', 'Active', 'Type'], 'string'],
            [['Dev_Name'], 'string', 'max' => 50],
            [['User_Flag'], 'string', 'max' => 20],
            [['User_Name', 'Zone', 'TermName'], 'string', 'max' => 32],
            [['User_Desc'], 'string', 'max' => 255],
            [['CourseName'], 'string', 'max' => 64],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'ID' => 'ID',
            'Dev_Name' => 'Dev  Name',
            'User_Flag' => 'User  Flag',
            'User_Name' => 'User  Name',
            'User_ID' => 'User  ID',
            'User_Desc' => 'User  Desc',
            'Zone' => 'Zone',
            'CourseName' => 'Course Name',
            'TermName' => 'Term Name',
            'SectionStart' => 'Section Start',
            'SectionEnd' => 'Section End',
            'WeekDay' => 'Week Day',
            'WeekStart' => 'Week Start',
            'WeekEnd' => 'Week End',
            'WeekType' => 'Week Type',
            'Active' => 'Active',
            'Type' => 'Type',
        ];
    }
}