<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/08/18 10:54
 */
namespace Workerman\iDste;
use common\models\BaseInfo;
use common\models\SystemLog;
use Workerman\Worker;
use Yii;

use Workerman\Lib\Timer;
use yii\db\Exception;
require_once __DIR__ . '/../Autoloader.php';
require_once  __DIR__ . '/../../common/classes/System.php';
require_once  __DIR__ . '/../../common/classes/Error.php';

class TimetableDaemon
{
    public function __construct($deamon){
        $deamon->onWorkerStart = [$this, 'workerStart'];
    }

    public function workerStart($worker){
        Timer::add(1, [$this, 'plan']);
    }

    public function log($msg){
        $fp = fopen("../idste_timetable_adapter.log", "a");
        $msg = date('Y-m-d H:i:s') . "$msg\n";
        fwrite($fp, $msg);
        fclose($fp);
    }

    public function dbReconnect()
    {
        while (true) {
            try {
                Yii::$app->db->close();
                Yii::$app->db->open();
                return;
            } catch (Exception $e) {
                echo "db error, wait. \n";
                sleep(1);
            }
        }
    }

    public function plan(){
        $this->dbReconnect();
        $bi = BaseInfo::findOne(['InfomationID' => 0x118]);
        if(empty($bi) || empty($bi->InfoValue) || $bi->InfoValue == 0)
            return;
        $autopower = BaseInfo::findOne(['InfomationID'=>0x119]);
        if(empty($autopower) || empty($autopower->InfoValue) || $autopower->InfoValue <= 0)
            return;
        $bi = BaseInfo::findOne(['InfomationID' => 0x11a]);
        if(empty($bi) || is_null($bi->InfoValue) || $bi->InfoValue < 0)
            $ahead = 0;
        else
            $ahead = $bi->InfoValue;
        $bi = BaseInfo::findOne(['InfomationID' => 0x11b]);
        if(empty($bi) || is_null($bi->InfoValue) || $bi->InfoValue < 0)
            $delay = 0;
        else
            $delay = $bi->InfoValue;

        $aheadLow = floor($ahead - 5);
        $sql = "select DevId from Timetable WHERE
                ((`Type` = 'normal' and TIMESTAMPDIFF(SECOND, TIME(NOW()), TIME(Start)) <= $ahead AND TIMESTAMPDIFF(SECOND, TIME(NOW()), TIME(Start)) > $aheadLow AND Weekday = WEEKDAY(NOW()) OR
                (`Type` = 'temporary' and TIMESTAMPDIFF(SECOND, NOW(), Start) >= 0 and TIMESTAMPDIFF(SECOND, NOW(), Start) < 5 )));";
        $devids = Yii::$app->db->createCommand($sql)->queryAll();
        foreach ($devids as $devid){
            Yii::$app->sendcmd2cmpn->sendCmd('DevCtrl', $devid["DevId"], ['PowerOn' => 'on',
                'cloudLogin'=>true]);//内部命令不验证token
        }
        $sql = "SELECT group_concat(DevId) as ids FROM Timetable WHERE
               ( `Type` = 'normal' and TIMESTAMPDIFF(SECOND, TIME(NOW()), TIME(`start`)) <= $ahead AND TIMESTAMPDIFF(SECOND, TIME(`End`), TIME(NOW())) < $delay AND Weekday = WEEKDAY(NOW())) OR
               ( `Type` = 'temporary' and TIMESTAMPDIFF(SECOND, `start`, NOW()) >= 0 AND TIMESTAMPDIFF(SECOND, `End`, NOW()) < 0);";
        $devs = Yii::$app->db->createCommand($sql)->queryAll();
        $delayHigth = floor($delay + 5);
        if(empty($devs) || !isset($devs['ids'])) {
            $sql = "select DevId from Timetable WHERE 
                   ((`Type` = 'normal' AND TIMESTAMPDIFF(SECOND, TIME(`End`), TIME(NOW())) < $delayHigth AND TIMESTAMPDIFF(SECOND, TIME(`End`), TIME(NOW())) >= $delay AND Weekday = WEEKDAY(NOW())) OR
                    (`Type` = 'temporary' AND TIMESTAMPDIFF(SECOND, `End`, NOW()) < 5 AND TIMESTAMPDIFF(SECOND, `End`, NOW()) >= 0)); ";
            $devids = Yii::$app->db->createCommand($sql)->queryAll();
            foreach ($devids as $devid){
                Yii::$app->sendcmd2cmpn->sendCmd('DevCtrl', $devid["DevId"], ['PowerOn' => 'off',
                   'cloudLogin'=>true]);//内部命令不验证token
            }
        }
        else {
            $sql = "select DevId from Timetable WHERE
                   ((`Type` = 'normal' AND TIMESTAMPDIFF(SECOND, TIME(`End`), TIME(NOW())) < $delayHigth AND TIMESTAMPDIFF(SECOND, TIME(`End`), TIME(NOW())) >= $delay AND b.Weekday = WEEKDAY(NOW())) OR
                    (`Type` = 'temporary' AND TIMESTAMPDIFF(SECOND, `End`, NOW()) < 5 AND TIMESTAMPDIFF(SECOND, `End`, NOW()) >= 0)) AND
                     DevId not in (" .$devs['ids'] . ");";
            $devids = Yii::$app->db->createCommand($sql)->queryAll();
            foreach ($devids as $devid){
                Yii::$app->sendcmd2cmpn->sendCmd('DevCtrl', $devid["DevId"], ['PowerOn' => 'off',
                    'cloudLogin'=>true]);//内部命令不验证token
            }
        }
    }
}
