-- MySQL Workbench Synchronization
-- Generated: 2018-06-29 11:26
-- Model: nccs
-- Version: D06.01.02
-- Project: idste-server
-- Author: xuhj(xuhj@idste.cn)

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

ALTER TABLE `nccs`.`BrdModeMember`
DROP FOREIGN KEY `BrdModeID`,
DROP FOREIGN KEY `ModeDeviceID`;

ALTER TABLE `nccs`.`DevCtrlSchedule`
DROP FOREIGN KEY `DevCtrlDevId`;

ALTER TABLE `nccs`.`DisableDevSession`
DROP FOREIGN KEY `DisDevShedule`,
DROP FOREIGN KEY `DisabledScheDevice`;

ALTER TABLE `nccs`.`MediaFiles`
DROP FOREIGN KEY `MediaUser`;

ALTER TABLE `nccs`.`MsgTaskDev`
DROP FOREIGN KEY `msgtaskdev`;

ALTER TABLE `nccs`.`PlaySessionTime`
DROP FOREIGN KEY `Schsessionid`;

ALTER TABLE `nccs`.`PlaySessions`
DROP FOREIGN KEY `SessionUser`;

ALTER TABLE `nccs`.`SessionDevice`
DROP FOREIGN KEY `SessionDevDev`,
DROP FOREIGN KEY `SessionDevSes`;

ALTER TABLE `nccs`.`Timetable`
DROP FOREIGN KEY `deviceIdKey`;

ALTER TABLE `nccs`.`UserDevices`
DROP FOREIGN KEY `UserId`,
DROP FOREIGN KEY `user_dev`;

ALTER TABLE `nccs`.`DeviceList`
ADD COLUMN `RtspUrl` VARCHAR(128) NULL DEFAULT NULL AFTER `CameraChannel`,
ADD COLUMN `Qrcode` INT(11) NULL DEFAULT NULL AFTER `RtspUrl`,
ADD COLUMN `RtspUrl1` VARCHAR(128) NULL DEFAULT NULL AFTER `Qrcode`,
ADD INDEX `Qrcode_idx` (`Qrcode` ASC);

ALTER TABLE `nccs`.`Event`
CHANGE COLUMN `StartTask` `StartTask` SMALLINT(6) UNSIGNED NULL DEFAULT NULL ,
CHANGE COLUMN `EndTask` `EndTask` SMALLINT(6) UNSIGNED NULL DEFAULT NULL ,
ADD INDEX `event_end_fkn_idx` (`EndTask` ASC),
ADD INDEX `event_start_fkn_idx` (`StartTask` ASC);

ALTER TABLE `nccs`.`PlaySessionTime`
ADD COLUMN `Length` INT(11) NULL DEFAULT NULL AFTER `TempFlag`;

CREATE TABLE IF NOT EXISTS `nccs`.`Qrcode` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `Code` VARCHAR(32) NOT NULL,
  `Type` ENUM('device', 'login', 'bind') NOT NULL DEFAULT 'device',
  `Url` VARCHAR(64) NULL DEFAULT NULL,
  `Context` VARCHAR(256) NULL DEFAULT NULL,
  `CreateAt` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `ExpireAt` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE INDEX `code_uni` (`Code` ASC),
  INDEX `code_idx` (`Code` ASC))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`SystemLog` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `at` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `ip` VARCHAR(16) NULL DEFAULT NULL,
  `result` INT(11) NOT NULL,
  `username` VARCHAR(255) NULL DEFAULT NULL,
  `title1` VARCHAR(255) NULL DEFAULT NULL,
  `title2` VARCHAR(255) NULL DEFAULT NULL,
  `type` VARCHAR(64) NOT NULL COMMENT 'controller name',
  `action` VARCHAR(64) NOT NULL COMMENT 'action name',
  `detail` VARCHAR(1024) NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  INDEX `systemlog_idx` (`username` ASC, `type` ASC, `ip` ASC))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

ALTER TABLE `nccs`.`Users`
ADD COLUMN `UnionId` VARCHAR(64) NULL DEFAULT NULL AFTER `Del_Flag`,
ADD UNIQUE INDEX `UnionId_uni` (`UnionId` ASC);

ALTER TABLE `nccs`.`BrdModeMember`
ADD CONSTRAINT `BrdModeID`
  FOREIGN KEY (`BrdModeID`)
  REFERENCES `nccs`.`BroadcastMode` (`idBroadcastMode`)
  ON DELETE CASCADE
  ON UPDATE NO ACTION,
ADD CONSTRAINT `ModeDeviceID`
  FOREIGN KEY (`DeviceID`)
  REFERENCES `nccs`.`DeviceList` (`DevID`)
  ON DELETE CASCADE
  ON UPDATE NO ACTION;

ALTER TABLE `nccs`.`DevCtrlSchedule`
ADD CONSTRAINT `DevCtrlDevId`
  FOREIGN KEY (`DevID`)
  REFERENCES `nccs`.`DeviceList` (`DevID`)
  ON DELETE CASCADE
  ON UPDATE NO ACTION;

ALTER TABLE `nccs`.`DeviceList`
ADD CONSTRAINT `Qrcode_fkn`
  FOREIGN KEY (`Qrcode`)
  REFERENCES `nccs`.`Qrcode` (`id`)
  ON DELETE SET NULL
  ON UPDATE NO ACTION;

ALTER TABLE `nccs`.`DisableDevSession`
ADD CONSTRAINT `DisDevShedule`
  FOREIGN KEY (`ScheduleID`)
  REFERENCES `nccs`.`PlaySessionTime` (`ScheduleID`)
  ON DELETE CASCADE
  ON UPDATE NO ACTION,
ADD CONSTRAINT `DisabledScheDevice`
  FOREIGN KEY (`DeviceID`)
  REFERENCES `nccs`.`DeviceList` (`DevID`)
  ON DELETE CASCADE;

ALTER TABLE `nccs`.`Event`
ADD CONSTRAINT `event_end_fkn`
  FOREIGN KEY (`EndTask`)
  REFERENCES `nccs`.`PlaySessions` (`SessionID`)
  ON DELETE SET NULL
  ON UPDATE NO ACTION,
ADD CONSTRAINT `event_start_fkn`
  FOREIGN KEY (`StartTask`)
  REFERENCES `nccs`.`PlaySessions` (`SessionID`)
  ON DELETE SET NULL
  ON UPDATE NO ACTION;

ALTER TABLE `nccs`.`MediaFiles`
ADD CONSTRAINT `MediaUser`
  FOREIGN KEY (`Owner`)
  REFERENCES `nccs`.`Users` (`User_ID`)
  ON DELETE SET NULL
  ON UPDATE NO ACTION;

ALTER TABLE `nccs`.`MsgTaskDev`
ADD CONSTRAINT `msgtaskdev`
  FOREIGN KEY (`DevID`)
  REFERENCES `nccs`.`DeviceList` (`DevID`)
  ON DELETE CASCADE
  ON UPDATE NO ACTION;

ALTER TABLE `nccs`.`PlaySessionTime`
ADD CONSTRAINT `Schsessionid`
  FOREIGN KEY (`SessionID`)
  REFERENCES `nccs`.`PlaySessions` (`SessionID`)
  ON DELETE CASCADE;

ALTER TABLE `nccs`.`PlaySessions`
ADD CONSTRAINT `SessionUser`
  FOREIGN KEY (`Owner`)
  REFERENCES `nccs`.`Users` (`User_ID`)
  ON DELETE SET NULL
  ON UPDATE NO ACTION;

ALTER TABLE `nccs`.`SessionDevice`
ADD CONSTRAINT `SessionDevDev`
  FOREIGN KEY (`DeviceID`)
  REFERENCES `nccs`.`DeviceList` (`DevID`)
  ON DELETE CASCADE,
ADD CONSTRAINT `SessionDevSes`
  FOREIGN KEY (`SessionID`)
  REFERENCES `nccs`.`PlaySessions` (`SessionID`)
  ON DELETE CASCADE;

ALTER TABLE `nccs`.`Timetable`
ADD CONSTRAINT `deviceIdKey`
  FOREIGN KEY (`DevId`)
  REFERENCES `nccs`.`DeviceList` (`DevID`)
  ON DELETE CASCADE
  ON UPDATE NO ACTION;

ALTER TABLE `nccs`.`UserDevices`
ADD CONSTRAINT `UserId`
  FOREIGN KEY (`UserID`)
  REFERENCES `nccs`.`Users` (`User_ID`)
  ON DELETE CASCADE
  ON UPDATE NO ACTION,
ADD CONSTRAINT `user_dev`
  FOREIGN KEY (`DevID`)
  REFERENCES `nccs`.`DeviceList` (`DevID`)
  ON DELETE CASCADE
  ON UPDATE NO ACTION;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
