#!/bin/sh


#校验当前运行的supervisord支持打开的最大文件数量是否大于5000
pid=`ps -e | grep supervisord | awk '{printf $1}'`
openLimit=`cat /proc/${pid}/limits  | grep "open files" | awk '{print $4}'`
if [ $? -eq 0 ]; then
    if [ $openLimit -ge 5000 ]; then
        return 0
    fi
fi



path=`systemctl status supervisor | grep loaded  | grep service | awk -F ';' '{print $1}' | awk -F '(' '{print $2}'`
if [ ! -f $path ]; then
    path="/lib/systemd/system/supervisor.service"
fi


count=`grep LimitNOFILE $path | wc -l`
if [ $? -eq 0 ]; then
    if [ $count -eq 1 ]; then
        sed -i  "s/LimitNOFILE=.*/LimitNOFILE=5000/" $path
    else
        sed -i  "/\[Service\]/a\LimitNOFILE=5000" $path
    fi
fi

systemctl daemon-reload
/etc/init.d/supervisor restart


mosPid=`ps -e | grep supervisor | awk '{printf $1}'`
openLimit=`cat /proc/${mosPid}/limits  | grep "open files" | awk '{print $4}'`
if [ $openLimit -ge 5000 ]; then
    return 0
fi

return -1

